/*************************************************************************/
/*                                                                       */
/*   icp3d.c: 3D ICP routines                                            */
/*                                                                       */
/*************************************************************************/

#ifndef _ICP3D_
#define _ICP3D_

#include <stdio.h>
#include <stdlib.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <fcntl.h>
#include <string.h>

#include <opencv/cv.h>
#include <opencv/highgui.h>

#include "icp3d.h"
#include "myutil.h"
#include "mesaRangeData.h"

#include <iostream>
#include <fstream>

#include "executeOPE.h"

/* f`p	*/

#define PP_NUM	13		//6Rx*2 + p[^
#define POINT_DATA_FILE "data.dat"
#define DEPTH_DATA_FILE "test5.dat"

#define MAX_POINT_NUM 10000
//fobOp
/*
#define DEBUG

#define PRINT_POINTS_CORRESPONDENCE

#define OUTPUT_IMAGE

#define OUTPUT_CORRESPONDENCE
*/
int objectid = 0;

int correspid = 0;

//SΉ_̑ʂ̑Ή_̊
double side_correspondence_rate;

/*********************************************************/
/*     ɂvg^Cv錾icp3d.h           */
/*********************************************************/
/***********************************************************/
/*                    ϐ`                         */
/***********************************************************/
/*  VvbNXp[^ԓ̓_̏W  */
parameter parameters[PP_NUM];

parameter object_pose;

/*  p[^p|C^  */
polytope *datapt, *modelpt, *temppt;

/*  ~󕨑̐pp[^p|C^*/
cylinder *datacy, *modelcy, *tempcy;

point	points[MAX_POINT_NUM], mpoints[MAX_POINT_NUM]; /*  f[^_ƃf_  */
int		corresponding_surface[MAX_POINT_NUM];			/*  f[^_̑Ή郂fID  */
#define NO_MATCH	(-1)

int	point_num=0;
int effective_point_num;

point	mp_data, mp_model;
int		is_effective[MAX_POINT_NUM];	/*  Ή_ǂ  */

int	previous_selected_surface=VERY_SMALL_INT; /* ʂ2xȂ */

FILE	*datafilep;
//dSƎ厲o

//̂̔ʗp
extern double offset;

//f[^_Q̏dS
point data_average;

//ʒupCʂ̏dSC1`3
extern CvPoint3D32f averageUpperSurface, vec1UpperSurface, vec2UpperSurface, vec3UpperSurface;
//ʂ̍
extern double distUpperSurface;

extern void show_axis(point averagep, point *axisp);

extern void show_initpoints(point *pp);

extern void show_initpoints_cylinder(point *initpointsp);

//ʒũ|Cg
point pp[8];

//ʒũ|Cg(ʂƒʂ̏dS)
point pp_cylinder[2];

//C[t[o͗p
double final_vertices_x[8];
double final_vertices_y[8];
double final_vertices_z[8];

//~̃C[t[o͗p
double final_cylinder_vertices_x[16];
double final_cylinder_vertices_y[16];
double final_cylinder_vertices_z[16];

/*  for debug */
int disp_errors=0, disp_errors2=0, face_num; /* used in geo.c */
int save_count=0;
int print_detail = 0;
int print_detail2 = 0;
/*  for debug */

int similar_side, similar_side_cp;

//łȂ]l̃p[^Ƃ̕]l
EstimateParameter vest_param;

//łȂ]l̂Ƃ̑Ή_
int correspondence_of_vestp;

//ʂ̑Ή_iAISTp[cE~̔pj
int side_correspondence_count;

void initialize_polytopes(double wx, double wy, double wz)
{
  modelpt = make_polytope(wx, wy, wz);
  temppt  = new_polytope(6, 4);	/* ̌ */
}
void initialize_cylinders(double height, double radius)
{
  modelcy = make_cylinder(height, radius);
  tempcy  = new_cylinder();
  //modelpttempptIȂ́imodelcy, tempcyj
}

/*  ̔̕w(gpȂ)  */
//eBbVu

 #define Block1X 0.058
 #define Block1Y 0.028
 #define Block1Z 0.122

void initialize_icp3d(int object_type)
{
	//~
	if(object_type == 1)
	{
		//~f֐
		printf("making_cylindermodel ");
		initialize_cylinders(CylinderHeight, CylinderRadius);
	}
	else
	{
		printf("making_boxmodel ");
		initialize_polytopes(Block1X, Block1Y, Block1Z);
	}
#ifdef OUTPUT_IMAGE
  initialize_superimpose();
#endif

}

void closing()
{
/* 
 *   finalize_random_generator();
 */
}

/*****************************/
/*  p[^l̃Zbg     */
/*****************************/
void set_parameter(parameter *param, double x, double y, double z, double tx, double ty, double tz)
{
  param->x = x;
  param->y = y;
  param->z = z;
  param->tx = tx;
  param->ty = ty;
  param->tz = tz;
}

/*****************************/
/*  VvbNX̐ݒ */
/*****************************/
void set_initial_parameters(double x0, double y0, double z0, double tx0, double ty0, double tz0)
{
  double	lambdax, lambday, lambdaz, lambdatx, lambdaty, lambdatz;

  lambdax = 0.1;
  lambday = 0.1;
  lambdaz = 0.1;
/* 
 *   lambdax = 0.2;
 *   lambday = 0.2;
 *   lambdaz = 0.2;
 */
/* 
 *   lambdax = 100.0;
 *   lambday = 100.0;
 *   lambdaz = 100.0;
 */
/* 
 *   lambdax = 200.0;
 *   lambday = 200.0;
 *   lambdaz = 200.0;
 */
/* 
 *   lambdatx = deg_to_rad(10.0);
 *   lambdaty = deg_to_rad(10.0);
 *   lambdatz = deg_to_rad(10.0);
 */
  lambdatx = deg_to_rad(20.0);
  lambdaty = deg_to_rad(20.0);
  lambdatz = deg_to_rad(20.0);
/* 
 *   lambdatx = deg_to_rad(50.0);
 *   lambdaty = deg_to_rad(50.0);
 *   lambdatz = deg_to_rad(50.0);
 */

  parameters[0].x = x0;
  parameters[0].y = y0;
  parameters[0].z = z0;
  parameters[0].tx = tx0;
  parameters[0].ty = ty0;
  parameters[0].tz = tz0;

  set_parameter(&parameters[1], x0 + lambdax, y0, z0, tx0, ty0, tz0);
  set_parameter(&parameters[2], x0 - lambdax, y0, z0, tx0, ty0, tz0);
  set_parameter(&parameters[3], x0, y0 + lambday, z0, tx0, ty0, tz0);
  set_parameter(&parameters[4], x0, y0 - lambday, z0, tx0, ty0, tz0);
  set_parameter(&parameters[5], x0, y0, z0 + lambdaz, tx0, ty0, tz0);
  set_parameter(&parameters[6], x0, y0, z0 - lambdaz, tx0, ty0, tz0);
  set_parameter(&parameters[7], x0, y0, z0, tx0 + lambdatx, ty0, tz0);
  set_parameter(&parameters[8], x0, y0, z0, tx0 - lambdatx, ty0, tz0);
  set_parameter(&parameters[9], x0, y0, z0, tx0, ty0 + lambdaty, tz0);
  set_parameter(&parameters[10], x0, y0, z0, tx0, ty0 - lambdaty, tz0);
  set_parameter(&parameters[11], x0, y0, z0, tx0, ty0, tz0 + lambdatz);
  set_parameter(&parameters[12], x0, y0, z0, tx0, ty0, tz0 - lambdatz);
}

/**********************************/
/*  p[^̕]lvZD
    p[^ɏ]ăfWϊC
    f[^_ƃfʂƂ̋̐Βli邢2j̕ςvZD

    ǂ̂悤ɕ]邩icp̒莮̖Ȃ̂ŁCŒ`D
*/
/**********************************/
double evaluate(parameter *p)
{
  int		i, j, effective_num, minj;
  double	min_dist, dist, sum_dist;
/* 
 *   double	   nx, ny, nz;
 */
  
//T̂߂̑ʑ̂Aό`B
  copy_polytope(modelpt, temppt);
  transform_polytope(temppt, p->x, p->y, p->z, p->tx, p->ty, p->tz);
  
/* 
 * 
 *   //ʑ̂̊eʂp[^ɂĕϊi@vZĂj
 *   for(i = 0;i < POLYGON_NUM; i++){
 *     transform_polygon(&(temppt->polygons[i]), p->x, p->y, p->z, p->tx, p->ty, p->tz);
 *   }
 * 
 */
  effective_num = 0;
  sum_dist = 0.0;

  if (print_detail) disp_errors = 1;
  
  for (i = 0; i < point_num; i++){ // f[^_Ƃɕ̂܂ł̍ŒZvZ
    min_dist = VERY_LARGE;
    for (j = 0; j < temppt->polygon_num; j++){
/*
*	  calc_normal(&(temppt->polygons[j]), &nx, &ny, &nz);
*/
      /* łɍČvZĂ̂ŁCł̌vZ͕sv */
/* 
 *	 nx = temppt->polygons[j].nx;
 *	 ny = temppt->polygons[j].ny;
 *	 nz = temppt->polygons[j].nz;
 */

/* 
 *	 if (similar_direction(points[i].nx, points[i].ny, points[i].nz, nx, ny, nz)){
 */
      if (print_detail && (j == 2)){
		fprintf(stderr, "Check Polygon[%d] <==> point[%d](%f, %f, %f)\n",
		j, i, points[i].x, points[i].y, points[i].z);
      }
      
      if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
			    temppt->polygons[j].nx,
			    temppt->polygons[j].ny,
			    temppt->polygons[j].nz))
	  {
		  //ʂ̖@
		if (print_detail && (j == 2)){
			fprintf(stderr, "  --> Similar direction!\n");
			if (i == 60  && print_detail2){
				fprintf(stderr, "!");
			}		
		}
		//f[^_ƃfʂ̋v
		dist = polygon_point_distance(&(temppt->polygons[j]), &(points[i]));
		if (print_detail && (j == 2)){
		  fprintf(stderr, " distance = %f (min is %f)\n", dist, min_dist);
		}
		
		if (dist < min_dist){
		  min_dist = dist;
		  minj = j;
		}
      }
    }
    
    if (min_dist < VERY_LARGE){
      /*  fobO\ptOD*/
      disp_errors2 = 1;
      face_num = minj;
      polygon_point_distance(&(temppt->polygons[minj]), &(points[i]));
      disp_errors2 = 0;

      sum_dist += min_dist;	/* L1 */
/*
*	 sum_dist += sqr(min_dist);
*/
      effective_num++;
    }
  }
  fprintf(stderr, "=> Effective num = %d: ", effective_num);
  
  if(effective_num != 0)
    sum_dist /= (double)effective_num;
  else
    sum_dist = VERY_LARGE;	

  //correspondence_of_vestp = effective_num;

  return(sum_dist);
/* 
 *   return(1.0 / (double)effective_num);
 */
}
/*
 * ~莞̃p[^̕]
 * f̏ʂƒʂƃf[^_̋̐Βl̕ςvZ
 */
double evaluate_disk(parameter *p)
{
	int		i, j, effective_num, minj;
	double	min_dist, dist, sum_dist;
	/* 
	*   double	   nx, ny, nz;
	*/

	int side_count = 0;  
	side_correspondence_count = 0;

	side_correspondence_rate = 0.0;

	//T̂߂̉~Aό`B  
	copy_cylinder(modelcy, tempcy);
	transform_cylinder(tempcy, p->x, p->y, p->z, p->tx, p->ty, p->tz);

	//Ή_̐C̑a
	effective_num = 0;
	sum_dist = 0.0;

	if (print_detail) disp_errors = 1;

	//  ofs_dotp.open("dotp.txt",std::ios::out);

	for (i = 0; i < point_num; i++){ // f[^_Ƃɕ̂܂ł̍ŒZvZ
		min_dist = VERY_LARGE;

		for (j = 0; j < 2; j++){

			if (print_detail){
				fprintf(stderr, "Check disk[%d] <==> point[%d](%f, %f, %f)\n",
				j, i, points[i].x, points[i].y, points[i].z);
			}

			if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
			tempcy->disks[j].nx,tempcy->disks[j].ny, tempcy->disks[j].nz))
			{

				if (print_detail){
		
					fprintf(stderr, "  --> Similar direction!\n");
					if (i == 60  && print_detail2){
						fprintf(stderr, "!");
					}
				}

				//ʁEʂƂ̋vZ
				dist = disk_point_distance(&(tempcy->disks[j]), &(points[i]));

				if (print_detail && (j == 2)){
					fprintf(stderr, " distance = %f (min is %f)\n", dist, min_dist);
				}

				if (dist < min_dist){
					min_dist = dist;
					minj = j;
				}
			}
			else
			{

				if(check_inside_model(&(points[i]), tempcy))
				{
					side_count++;
					//ʂƂ̋vZ
					dist = side_point_distance(tempcy, &(points[i]));

					if (print_detail){
						fprintf(stderr, " distance = %f (min is %f)\n", dist, min_dist);
					}

					if (dist < min_dist){
						side_correspondence_count++;
						min_dist = dist;
						minj = 2;
					}
				}
			}
		}

		if (min_dist < VERY_LARGE){
		/*  fobO\ptOD*/
			disp_errors2 = 1;
			face_num = minj;

			if(minj < 2)
				disk_point_distance(&(tempcy->disks[minj]), &(points[i]));
			else
				side_point_distance(tempcy, &(points[i]));

			disp_errors2 = 0;

			sum_dist += min_dist;	/* L1 */
		/*
		*	 sum_dist += sqr(min_dist);
		*/
			effective_num++;
		}
	}
	fprintf(stderr, "=> Effective num = %d: ", effective_num);

	if(effective_num != 0)
		sum_dist /= (double)effective_num;
	else
		sum_dist = VERY_LARGE;	

	//  ofs_dotp.close();

	printf("side_count:%d\n",side_count);
	printf("side_correspondence_count:%d\n",side_correspondence_count);

	side_correspondence_rate = (double)side_correspondence_count / (double)effective_num;

	printf("side_correspondence_rate:%.3f\n",side_correspondence_rate);

	return(sum_dist);
}

/*
  ̂OƂāCf[^_pp[^̏l߂D
  ԒzCԖڂɒxłƉ肷D
*/
void calc_initial_orientation(int point_num, point *points,
			      double *x_theta, double *y_theta, double *z_theta)
{
  CvMat *source;
  CvMat *average,*eigenValues,*eigenVectors;

  int i;
  double x, y, z;

  source  = cvCreateMat(point_num,DATA_DIM,CV_32F);  
  average = cvCreateMat(1,DATA_DIM,CV_32F);
  eigenValues  = cvCreateMat(1,PCA_DIM,CV_32F);
  eigenVectors = cvCreateMat(PCA_DIM,DATA_DIM,CV_32F);

  for(i = 0; i < point_num; i++)
  {
	cvmSet(source, i, 0, points[i].x);
	cvmSet(source, i, 1, points[i].y);
	cvmSet(source, i, 2, points[i].z);
  }

  // PCAɂ
  cvCalcPCA(source,average,eigenValues,eigenVectors,CV_PCA_DATA_AS_ROW);

  //厲
  x = cvmGet(eigenVectors, 0, 0);
  y = cvmGet(eigenVectors, 0, 1);
  z = cvmGet(eigenVectors, 0, 2);

  fprintf(stderr, " After PCA = (%f, %f, %f)\n", x, y, z);

  //ɂȂĂxNgɏC
  /* 
    ZTWnł͑OzCyCx ̂ꂼꐳ̌D
    厲 y̐悤ɂĂiȂĂ͂ȂHj
  */

  if(y < 0.0)
  {
	x = -x;
	y = -y;
	z = -z;
  }

  fprintf(stderr, "PC1 = (%f, %f, %f)\n", x, y, z);

  /*
    (0, 0, 1) ϊƁH
    
    x = sin(ty)
    y = -sin(tx)cos(ty)
    z = cos(tx)cos(ty)

    --> tan(tx) = -y/z
    --> tan(ty) = -x sin(tx) / y
  */

  *x_theta = atan2(-y, z);
  *y_theta = atan2(-x * sin(*x_theta), y);
  
  x = cvmGet(eigenVectors, 1, 0);
  y = cvmGet(eigenVectors, 1, 1);
  z = cvmGet(eigenVectors, 1, 2);
  /*
    (1, 0, 0) ϊƁH
    
    x = cos(ty)cos(tz)
    y = sin(tx)sin(ty)cos(tz)+cos(tx)sin(tz)
    z = -cos(tx)sin(ty)cos(tz)+sin(tx)sin(tz)

    ŏ̂Q
    --> cos(tz) = x / cos(ty)
        sin(tz) = (y - sin(tx)sin(ty) * x/cos(ty)) / cos(tx)
  */

  fprintf(stderr, "PC2 = (%f, %f, %f)\n", x, y, z);

  *z_theta = atan2((y - sin(*x_theta)*sin(*y_theta)*x/cos(*y_theta)) / cos(*x_theta),
		   x / cos(*y_theta));
  
  // 
  cvReleaseMat(&source);
  cvReleaseMat(&average);
  cvReleaseMat(&eigenValues);
  cvReleaseMat(&eigenVectors);
}

/*
 * pvZi͎gpĂȂj
 */
void calc_initial_pose(int point_num, point *points, parameter *retp)
{
  int		i;
  double	sx, sy, sz;

  sx = sy = sz = 0.0;
  for (i = 0; i < point_num; i++){
    sx += points[i].x;
    sy += points[i].y;
    sz += points[i].z;
  }
  retp->x = sx / (double)point_num;
  retp->y = sy / (double)point_num;
  retp->z = sz / (double)point_num;

  calc_initial_orientation(point_num, points, &(retp->tx), &(retp->ty), &(retp->tz));
}

/*  萳dSʒuvZ邱ƂɂCԂł̏dȂǂD*/
/*  dSɁC2C3ɕsړCƂdȂ肪悢̂TH  */
/*  厲ɉčőŏ̒l΂悢Hicalc_initial_orientation ̒Hj
    @No. `̑Sʂ2ӂĂȂE
    @YesD厲ƕӂ̕ align Ă΂ł悢͂D*/
void calc_initial_pose2(int point_num, point *points, parameter *retp)
{
  /*  ܂PCAāCf[^_̏dSƎ厲vZ  */

  CvMat *source;
  CvMat *average,*eigenValues,*eigenVectors;
  CvMat *tempVec1, *tempVec2, subMat1, subMat2;
  
  double	minval[3], meanval[3], maxval[3], diffval[3];

  int i, j;
  double x, y, z, tx, ty, tz;

  source  = cvCreateMat(point_num,DATA_DIM,CV_32F);  
  average = cvCreateMat(1,DATA_DIM,CV_32F);
  eigenValues  = cvCreateMat(1,PCA_DIM,CV_32F);
  eigenVectors = cvCreateMat(PCA_DIM,DATA_DIM,CV_32F);

  tempVec1 = cvCreateMat(1, DATA_DIM, CV_32F);
  tempVec2 = cvCreateMat(1, DATA_DIM, CV_32F);

  for(i = 0; i < point_num; i++)
  {
	cvmSet(source, i, 0, points[i].x);
	cvmSet(source, i, 1, points[i].y);
	cvmSet(source, i, 2, points[i].z);
  }

  // PCAɂ
  cvCalcPCA(source,average,eigenValues,eigenVectors,CV_PCA_DATA_AS_ROW);

//  show_CvMat("PC0", cvGetRow(eigenVectors, &subMat1, 0));
//  show_CvMat("PC1", cvGetRow(eigenVectors, &subMat1, 1));
//  show_CvMat("PC2", cvGetRow(eigenVectors, &subMat1, 2));

  //厲
  /*  eɉčőlCŏlCϒl}bsO̒l߁C
      ̕Caverage 炸炷D*/
  
  for (j = 0; j < 3; j++){
    maxval[j] = VERY_SMALL; minval[j] = VERY_LARGE;
  }
  for (i = 0; i < point_num; i++){
    for (j = 0; j < 3; j++){
      maxval[j] = max(maxval[j], cvDotProduct(cvGetRow(eigenVectors, &subMat1, j),
					      cvGetRow(source, &subMat2, i)));
      minval[j] = min(minval[j], cvDotProduct(cvGetRow(eigenVectors, &subMat1, j),
					      cvGetRow(source, &subMat2, i)));
    }
  }

  fprintf(stderr, "Average: (%f, %f, %f)\n",
	  cvmGet(average, 0, 0), cvmGet(average, 0, 1), cvmGet(average, 0, 2));
  
  for (j = 0; j < 3; j++){
    meanval[j] = cvDotProduct(cvGetRow(eigenVectors, &subMat1, j), average);
    diffval[j] = (maxval[j] + minval[j]) / 2.0 - meanval[j];
    fprintf(stderr, " MinVal[%d] = %f, MaxVal[%d] = %f, Mean = %f\n", j, minval[j],
	    j, maxval[j], meanval[j]);
    fprintf(stderr, " Diffval[%d] = %f\n", j, diffval[j]);
  }
  CvScalar scalar = cvScalarAll(diffval[0]);
  /* cvScaleAdd(A, s, B, C):  C = s*A + B  */
  cvScaleAdd(cvGetRow(eigenVectors, &subMat1, 0), scalar, average, tempVec1);
  scalar = cvScalarAll(diffval[1]);
  cvScaleAdd(cvGetRow(eigenVectors, &subMat1, 1), scalar, tempVec1, tempVec2);
  scalar = cvScalarAll(diffval[2]);
  cvScaleAdd(cvGetRow(eigenVectors, &subMat1, 2), scalar, tempVec2, tempVec1);
  retp->x = cvmGet(tempVec1, 0, 0);
  retp->y = cvmGet(tempVec1, 0, 1);
  retp->z = cvmGet(tempVec1, 0, 2);
  
  fprintf(stderr, "New Average: (%f, %f, %f)\n", retp->x, retp->y, retp->z);
  /*  iI  */
  
  /*  ]I  */
  /*  1  */
  x = cvmGet(eigenVectors, 0, 0);
  y = cvmGet(eigenVectors, 0, 1);
  z = cvmGet(eigenVectors, 0, 2);

  fprintf(stderr, " After PCA = (%f, %f, %f)\n", x, y, z);

  //ɂȂĂxNgɏC
  /* 
    ZTWnł͑OzCyCx ̂ꂼꐳ̌D
    厲 y̐悤ɂĂiȂĂ͂ȂHj
  */

/* 
 *   if(y < 0.0)
 *   {
 *	   x = -x;
 *	   y = -y;
 *	   z = -z;
 *   }
 */

  fprintf(stderr, "PC1 = (%f, %f, %f)\n", x, y, z);

  /*
    (0, 0, 1) ϊƁH
    
    x = sin(ty)
    y = -sin(tx)cos(ty)
    z = cos(tx)cos(ty)

    --> tan(tx) = -y/z
    --> tan(ty) = -x sin(tx) / y
  */

  tx = atan2(-y, z);
  ty = atan2(-x * sin(tx), y);

  /*  2  */
  x = cvmGet(eigenVectors, 1, 0);
  y = cvmGet(eigenVectors, 1, 1);
  z = cvmGet(eigenVectors, 1, 2);
  /*
    (1, 0, 0) ϊƁH
    
    x = cos(ty)cos(tz)
    y = sin(tx)sin(ty)cos(tz)+cos(tx)sin(tz)
    z = -cos(tx)sin(ty)cos(tz)+sin(tx)sin(tz)

    ŏ̂Q
    --> cos(tz) = x / cos(ty)
        sin(tz) = (y - sin(tx)sin(ty) * x/cos(ty)) / cos(tx)
  */

  fprintf(stderr, "PC2 = (%f, %f, %f)\n", x, y, z);

  tz = atan2((y - sin(tx)*sin(ty)*x/cos(ty)) / cos(tx), x / cos(ty));

  retp->tx = tx;
  retp->ty = ty;
  retp->tz = tz;
  
  // 
  cvReleaseMat(&source);
  cvReleaseMat(&average);
  cvReleaseMat(&eigenValues);
  cvReleaseMat(&eigenVectors);
  cvReleaseMat(&tempVec1);
  cvReleaseMat(&tempVec2);
}

/*
 * PCAg킸ɏp߂
 */
void calc_initial_pose_notpca(int point_num, point *points, parameter *retp)
{
  int		i;
  double	sx, sy, sz, tx, ty, tz;
  double    axisx, axisy, axisz;

  sx = sy = sz = 0.0;
  for (i = 0; i < point_num; i++){
    sx += points[i].x;
    sy += points[i].y;
    sz += points[i].z;
  }
  retp->x = sx / (double)point_num;
  retp->y = sy / (double)point_num;
  retp->z = sz / (double)point_num;

  //̃xNgi~̎厲jvZ
  axisx = points[0].x - points[1].x;
  axisy = points[0].y - points[1].y;
  axisz = points[0].z - points[1].z;

  double norm = sqrt(pow(axisx, 2.0) + pow(axisy, 2.0) + pow(axisz, 2.0));

  axisx /= norm;
  axisy /= norm;
  axisz /= norm;

  fprintf(stderr, " After PCA = (%f, %f, %f)\n", axisx, axisy, axisz);

  //ɂȂĂxNgɏC
  /* 
    ZTWnł͑OzCyCx ̂ꂼꐳ̌D
    厲 y̐悤ɂĂiȂĂ͂ȂHj
  */

  if(axisy < 0.0)
  {
	axisx = -axisx;
	axisy = -axisy;
	axisz = -axisz;
  }

  fprintf(stderr, "PC1 = (%f, %f, %f)\n", axisx, axisy, axisz);

  /*
    (0, 0, 1) ϊƁH
    
    x = sin(ty)
    y = -sin(tx)cos(ty)
    z = cos(tx)cos(ty)

    --> tan(tx) = -y/z
    --> tan(ty) = -x sin(tx) / y
  */

  tx = atan2(-axisy, axisz);
  ty = atan2(-axisx * sin(tx), axisy);
  tz = 0.0;

  retp->tx = tx;
  retp->ty = ty;
  retp->tz = tz;
}

//oIɁC=1.0, =0.5, =2.0ǂƌĂD
#define ALPHA 1.0
#define BETA 0.5
#define GAMMA 2.0
#define DELTA 0.5

#define MAX_COUNT 1000
/* 
 * #define MU 1.0e-4
 */
#define MU 1.0e-3
/*
 * ICP̌vZi͎gpĂȂj
 */
parameter icp(double *bestevaluation)
{
  int		i, count;
  double	bestval, secondworstval, worstval;
  int		besti, secondworsti, worsti;
  double	previousx, previousy, previousz, previoustx, previousty, previoustz;
  
  parameter gp, refp, extp, conp;
  double evals[PP_NUM], refval, extval, conval;
  double term_cond;

  previousx = previousy = previousz = previoustx = previousty = previoustz = VERY_LARGE;
  
  count = 0;
  while (1){
    /*  e_̕]  */
    bestval = VERY_LARGE;
    worstval = VERY_SMALL;
    fprintf(stderr, "Evaluations:\n");
    for (i = 0; i < PP_NUM; i++){
      evals[i] = evaluate(&parameters[i]);
      fprintf(stderr, "%f (%3.3f,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f)\n", evals[i],
	      parameters[i].x, parameters[i].y, parameters[i].z,
	      rad_to_deg(parameters[i].tx), rad_to_deg(parameters[i].ty),
	      rad_to_deg(parameters[i].tz));
	  
      if (evals[i] < bestval){
	bestval = evals[i];
	besti = i;
      }
      if (evals[i] > worstval){
	if (worstval != VERY_SMALL){
	  secondworstval = worstval;
	  secondworsti = worsti;
	}
	worstval = evals[i];
	worsti = i;
      }
    }
    fprintf(stderr, "\n");

    /*  ̃xXg̑Ή֌WƋ𒲂ׂD(DEBUG) */
/* 
 *     if (count == 0){
 *	 fprintf(stderr, "START: Examine initial correspondences.\n");
 *	 print_detail = 1;
 *	 evaluate(&parameters[besti]);
 *	 print_detail = 0;
 *	 disp_errors = 0;
 *	 fprintf(stderr, "END: Examine initial correspondences.\n");
 *     }
 */
    /*  ̑Ή֌WƋׂĒׂD(DEBUG) */
/* 
 *     if (count == 0){
 *	 for (i = 0; i < PP_NUM; i++){
 *	   fprintf(stderr, "START: Examine initial correspondences[%2d].\n", i);
 *	   print_detail = 1;
 *	   evaluate(&parameters[i]);
 *	   print_detail = 0;
 *	   disp_errors = 0;
 *	   fprintf(stderr, "\nEND: Examine initial correspondences[%2d].\n", i);
 *	 }
 *     }
 */

    /*  I  */
    if (count > MAX_COUNT) break;

	/* [h*/
    if(worstval < 0.00001) break;

    /*  IDxXgƃ[Xg̐Kꂽ  */
    term_cond = (2.0 * fabs(worstval - bestval))/(fabs(worstval)+fabs(bestval));
    fprintf(stderr, "eval[%d] = [%f, %f]\n", count, bestval, worstval);
    fprintf(stderr, " termination condition = %f\n", term_cond);

    if ((parameters[besti].x != previousx) ||
	(parameters[besti].y != previousy) ||
	(parameters[besti].z != previousy) ||
	(parameters[besti].tx != previoustx) ||
	(parameters[besti].ty != previousty) ||
	(parameters[besti].tz != previoustz)){ /* O񂩂̕ω */
      fprintf(stderr, "save polygon-%03d\n", save_count);
      
#ifdef OUTPUT_IMAGE
      output_scene_positions_to_image(0,
				      parameters[besti].x,
				      parameters[besti].y,
				      parameters[besti].z,
				      parameters[besti].tx,
				      parameters[besti].ty,
				      parameters[besti].tz);
#endif
      
/* 
 *	 if (save_count == 287){
 *	   print_detail = 1;
 *	 }
 */

      /*  ́iVȁjlۑ  */
      previousx = parameters[besti].x;
      previousy = parameters[besti].y;
      previousz = parameters[besti].z;
      previoustx = parameters[besti].tx;
      previousty = parameters[besti].ty;
      previoustz = parameters[besti].tz;
    }

    if (MU > term_cond) break;

    /*  ň_dŠvZ  */
    gp.x = gp.y = gp.z = gp.tx = gp.ty = gp.tz = 0.0;
    
    for (i = 0; i < PP_NUM; i++){
      if (i != worsti){
	gp.x += parameters[i].x;
	gp.y += parameters[i].y;
	gp.z += parameters[i].z;
	gp.tx += parameters[i].tx;
	gp.ty += parameters[i].ty;
	gp.tz += parameters[i].tz;
      }
    }
    gp.x /= (double)(PP_NUM - 1);
    gp.y /= (double)(PP_NUM - 1);
    gp.z /= (double)(PP_NUM - 1);
    gp.tx /= (double)(PP_NUM - 1);
    gp.ty /= (double)(PP_NUM - 1);
    gp.tz /= (double)(PP_NUM - 1);

    /*  ˑ  */
    refp.x = (1 + ALPHA) * gp.x - ALPHA * parameters[worsti].x;
    refp.y = (1 + ALPHA) * gp.y - ALPHA * parameters[worsti].y;
    refp.z = (1 + ALPHA) * gp.z - ALPHA * parameters[worsti].z;
    refp.tx = (1 + ALPHA) * gp.tx - ALPHA * parameters[worsti].tx;
    refp.ty = (1 + ALPHA) * gp.ty - ALPHA * parameters[worsti].ty;
    refp.tz = (1 + ALPHA) * gp.tz - ALPHA * parameters[worsti].tz;
    fprintf(stderr, "==> reflection 1\n");

    refval = evaluate(&refp);
    fprintf(stderr, "%f (%3.3f,%3.3f,%3.3f,%3.3f,%3.3f,%3.3f)", refval,
	    refp.x, refp.y, refp.z,
	    rad_to_deg(refp.tx), rad_to_deg(refp.ty), rad_to_deg(refp.tz));

    if (refval < bestval){	/*  ˑ삪ǂꍇCL΂ */
      /*  g呀  */
      extp.x = GAMMA * refp.x + (1 - GAMMA) * gp.x;
      extp.y = GAMMA * refp.y + (1 - GAMMA) * gp.y;
      extp.z = GAMMA * refp.z + (1 - GAMMA) * gp.z;
      extp.tx = GAMMA * refp.tx + (1 - GAMMA) * gp.tx;
      extp.ty = GAMMA * refp.ty + (1 - GAMMA) * gp.ty;
      extp.tz = GAMMA * refp.tz + (1 - GAMMA) * gp.tz;
      extval = evaluate(&extp);	// ĂI

      if (extval < refval){	/*  ext  ref ǂ΁Cworst  ext Œu */
		parameters[worsti].x = extp.x;
		parameters[worsti].y = extp.y;
		parameters[worsti].z = extp.z;
		parameters[worsti].tx = extp.tx;
		parameters[worsti].ty = extp.ty;
		parameters[worsti].tz = extp.tz;
		fprintf(stderr, "==> enlargement\n");
      }
      else{	/*  worst  ref Œu */
		parameters[worsti].x = refp.x;
		parameters[worsti].y = refp.y;
		parameters[worsti].z = refp.z;
		parameters[worsti].tx = refp.tx;
		parameters[worsti].ty = refp.ty;
		parameters[worsti].tz = refp.tz;
		fprintf(stderr, "==> reflection 2\n");
      }
    }
    else if ((secondworstval < refval) && (refval < worstval))
	{
      /* ˑ삪ZJh[Xg͈C[Xg͗ǂꍇ */
      
      conp.x = BETA * gp.x + (1.0 - BETA) * parameters[worsti].x;
      conp.y = BETA * gp.y + (1.0 - BETA) * parameters[worsti].y;
      conp.z = BETA * gp.z + (1.0 - BETA) * parameters[worsti].z;
      conp.tx = BETA * gp.tx + (1.0 - BETA) * parameters[worsti].tx;
      conp.ty = BETA * gp.ty + (1.0 - BETA) * parameters[worsti].ty;
      conp.tz = BETA * gp.tz + (1.0 - BETA) * parameters[worsti].tz;

      conval = evaluate(&conp);

      if (conval < worstval){		/*  worst  con Œu */
		parameters[worsti].x = conp.x;
		parameters[worsti].y = conp.y;
		parameters[worsti].z = conp.z;
		parameters[worsti].tx = conp.tx;
		parameters[worsti].ty = conp.ty;
		parameters[worsti].tz = conp.tz;
		fprintf(stderr, "==> contraction 1\n");
      }
      else{			/* ks */
	for (i = 0; i < PP_NUM; i++){
	  parameters[i].x = DELTA * parameters[i].x + (1.0-DELTA) * parameters[besti].x;
	  parameters[i].y = DELTA * parameters[i].y + (1.0-DELTA) * parameters[besti].y;
	  parameters[i].z = DELTA * parameters[i].z + (1.0-DELTA) * parameters[besti].z;
	  parameters[i].tx = DELTA*parameters[i].tx + (1.0-DELTA) * parameters[besti].tx;
	  parameters[i].ty = DELTA*parameters[i].ty + (1.0-DELTA) * parameters[besti].ty;
	  parameters[i].tz = DELTA*parameters[i].tz + (1.0-DELTA) * parameters[besti].tz;
	}
	fprintf(stderr, "==> reduction 1\n");
      }
    }
    else if (worstval <= refval){ /* ˑ삪[Xg舫ꍇ */
      /*  ks  */
      conp.x = BETA * gp.x + (1.0 - BETA) * parameters[worsti].x;
      conp.y = BETA * gp.y + (1.0 - BETA) * parameters[worsti].y;
      conp.z = BETA * gp.z + (1.0 - BETA) * parameters[worsti].z;
      conp.tx = BETA * gp.tx + (1.0 - BETA) * parameters[worsti].tx;
      conp.ty = BETA * gp.ty + (1.0 - BETA) * parameters[worsti].ty;
      conp.tz = BETA * gp.tz + (1.0 - BETA) * parameters[worsti].tz;

      conval = evaluate(&conp);
      
      if (conval < worstval){
	/*  worst  con Œu */
	parameters[worsti].x = conp.x;
	parameters[worsti].y = conp.y;
	parameters[worsti].z = conp.z;
	parameters[worsti].tx = conp.tx;
	parameters[worsti].ty = conp.ty;
	parameters[worsti].tz = conp.tz;
	fprintf(stderr, "==> contraction 2\n");
      }
      else{
	/* ks */
	for (i = 0; i < PP_NUM; i++){
	  parameters[i].x = DELTA*parameters[i].x + (1.0-DELTA) * parameters[besti].x;
	  parameters[i].y = DELTA*parameters[i].y + (1.0-DELTA) * parameters[besti].y;
	  parameters[i].z = DELTA*parameters[i].z + (1.0-DELTA) * parameters[besti].z;
	  parameters[i].tx = DELTA*parameters[i].tx + (1.0-DELTA) * parameters[besti].tx;
	  parameters[i].ty = DELTA*parameters[i].ty + (1.0-DELTA) * parameters[besti].ty;
	  parameters[i].tz = DELTA*parameters[i].tz + (1.0-DELTA) * parameters[besti].tz;
	}
	fprintf(stderr, "==> reduction 2\n");
      }
    }
    else{
      /*  worst  ref Œu  */
      parameters[worsti].x = refp.x;
      parameters[worsti].y = refp.y;
      parameters[worsti].z = refp.z;
      parameters[worsti].tx = refp.tx;
      parameters[worsti].ty = refp.ty;
      parameters[worsti].tz = refp.tz;
      fprintf(stderr, "==> reflection 3\n");
    }

    count++;
    save_count++;
  }

/* 
 *   save_count++;
 */

  fprintf(stderr, "(x, y, z, tx, ty, tz) = (%f, %f, %f, %f, %f, %f)\n",
	  parameters[besti].x, parameters[besti].y, parameters[besti].z,
	  rad_to_deg(parameters[besti].tx),
	  rad_to_deg(parameters[besti].ty),
	  rad_to_deg(parameters[besti].tz));

  *bestevaluation = bestval;
  return (parameters[besti]);
}
/*******************************************  ICP using Nelder-Mead Method *****************************************/

/************************************************  ICP using SVD  **************************************************/

void solve_RT(int point_num, point *points, point *mpoints, int *is_effective,
	      CvMat *R, CvMat *t)
{
  /*  f_Q̕ψʒu߂D--> solve_RT ĂԑOɌvZ悤ɂ  */

  int	i;

#ifdef OUTPUT_CORRESPONDENCE
/* 
 *   #define SKIP_NUM	   20
 */
  #define SKIP_NUM	1

  int	pcount = 0;
  for (i = 0; i < point_num; i++){
    if (is_effective[i]){
      pcount++;
      if (pcount == SKIP_NUM){
	/*  show data  */
/* 
 *	   fprintf(stderr, " show[%3d]: ", i);
 */
	show_correspondence(0, points[i], mpoints[i]); /* last image exists? */
	pcount = 0;
      }
    }
  }

  show_correspondence(1, points[0], mpoints[0]); /* do not care about point data */
  
  printf("show correspondence ok ? ");
//  getchar();
#endif

  // cvCreateMat: (sCCCV_32F)

  /*  s  */
  CvMat *X = cvCreateMat(3, effective_point_num, CV_32F);
  CvMat *Y = cvCreateMat(3, effective_point_num, CV_32F);
  CvMat *YT = cvCreateMat(effective_point_num, 3, CV_32F);
  CvMat *XY = cvCreateMat(3, 3, CV_32F);
  CvMat *W = cvCreateMat(3, 3, CV_32F);
  CvMat *U = cvCreateMat(3, 3, CV_32F);
  CvMat *UT = cvCreateMat(3, 3, CV_32F);
  CvMat *V = cvCreateMat(3, 3, CV_32F);
  CvMat *VT = cvCreateMat(3, 3, CV_32F);
  CvMat *VU = cvCreateMat(3, 3, CV_32F);
  CvMat *H = cvCreateMat(3, 3, CV_32F);
  CvMat *tempMat = cvCreateMat(3, 3, CV_32F);
  
  /*  xNg  */
  CvMat *mx = cvCreateMat(3, 1, CV_32F);
  CvMat *my = cvCreateMat(3, 1, CV_32F);
  CvMat *tempVec = cvCreateMat(3, 1, CV_32F);
  cvmSet(mx, 0, 0, mp_model.x);
  cvmSet(mx, 1, 0, mp_model.y);
  cvmSet(mx, 2, 0, mp_model.z);
  cvmSet(my, 0, 0, mp_data.x);
  cvmSet(my, 1, 0, mp_data.y);
  cvmSet(my, 2, 0, mp_data.z);

  /*  ϊp[^  */
/* 
 *   CvMat *R = cvCreateMat(3, 3, CV_32F);
 *   CvMat *t = cvCreateMat(3, 1, CV_32F);
 */

  /*  ψʒu_Qׂs X' Y' 𐶐D
      OpenCV  SVD ֐g`ɂD*/
  int count = 0;
  for (i = 0; i < point_num; i++){
    if (is_effective[i]){
      cvmSet(X, 0, count, mpoints[i].x - mp_model.x);
      cvmSet(X, 1, count, mpoints[i].y - mp_model.y);
      cvmSet(X, 2, count, mpoints[i].z - mp_model.z);

      /*  ͍ŏɈxĂ΂悢͂
       @@@effective ȃf[^_͖ς̂ł͂łȂD
             mp_data vZKvD*/
      cvmSet(Y, 0, count, points[i].x - mp_data.x);
      cvmSet(Y, 1, count, points[i].y - mp_data.y);
      cvmSet(Y, 2, count, points[i].z - mp_data.z);

      count++;
    }
  }

/* 
 *   show_CvMat("X'", X);
 *   show_CvMat("Y'", Y);
 */
  /*  ϒlŃItZbgĂ邩ǂ̊mF  */
/* 
 *   do_CvMatOp(0, X);
 *   do_CvMatOp(0, Y);
 */

  cvmTranspose(Y, YT);		/* vZĂ͂ */
  cvmMul(X, YT, XY);

  /*  SVD ̌vZ  */
  cvSVD(XY, W, U, V, CV_SVD_MODIFY_A);
  cvmTranspose(U, UT);
  cvmTranspose(V, VT);
  cvmMul(V, UT, VU);

  /*  s񎮁1 ̐𖞂悤ɉ]s𐶐  */
  /*  R = V H UT, H = diag(1, 1, det(V UT))         */
  cvmSet(H, 0, 0, 1.0);
  cvmSet(H, 0, 1, 0.0);
  cvmSet(H, 0, 2, 0.0);
  cvmSet(H, 1, 0, 0.0);
  cvmSet(H, 1, 1, 1.0);
  cvmSet(H, 1, 2, 0.0);
  cvmSet(H, 2, 0, 0.0);
  cvmSet(H, 2, 1, 0.0);
  cvmSet(H, 2, 2, cvmDet(VU));

  cvmMul(V, H, tempMat);
  cvmMul(tempMat, UT, R);

  /*  ǐvZ  */
  cvmSet(mx, 0, 0, -1.0 * cvmGet(mx, 0, 0));
  cvmSet(mx, 1, 0, -1.0 * cvmGet(mx, 1, 0));
  cvmSet(mx, 2, 0, -1.0 * cvmGet(mx, 2, 0));
  cvmMul(R, mx, tempVec);
  cvmAdd(my, tempVec, t);

#if 0
  /*  ܂łŁCO񂩂̍WϊꂽD*/
  /*  Oƍ̍āCŏIIȕϊ𓾂̂ solve_RT oĂD*/

  newp->x = cvmGet(t, 0, 0);
  newp->y = cvmGet(t, 1, 0);
  newp->z = cvmGet(t, 2, 0);

  /*  ]s񂩂̉]̌vZ  */
  /*  { R, t ̂܂܎Ă΂͂D*/

  newp->tx = atan2(- cvmGet(R, 1, 2), cvmGet(R, 2, 2));
  newp->tz = atan2(- cvmGet(R, 0, 1), cvmGet(R, 0, 0));

  double cy = sign(cvmGet(R, 2, 2)) * sign(cos(newp->tx))
    * sqrt(sqr(cvmGet(R, 1, 2)) + sqr(cvmGet(R, 2, 2)));
  newp->ty = atan2(cvmGet(R, 0, 2), cy);

  check_decomposition(R, newp);	/* e܂̉]ւ̕ǂ`FbN */
#endif
  
  /*  L̈̉  */
  cvReleaseMat(&X);
  cvReleaseMat(&Y);
  cvReleaseMat(&YT);
  cvReleaseMat(&XY);
  cvReleaseMat(&W);
  cvReleaseMat(&U);
  cvReleaseMat(&UT);
  cvReleaseMat(&V);
  cvReleaseMat(&VT);
  cvReleaseMat(&VU);
  cvReleaseMat(&H);
  cvReleaseMat(&tempMat);
  
  /*  xNg  */
  cvReleaseMat(&mx);
  cvReleaseMat(&my);
  cvReleaseMat(&tempVec);

  /*  ϊp[^  */
/* 
 *   cvReleaseMat(&R);
 *   cvReleaseMat(&t);
 */
}

void compose_transformation_with_parameters(parameter *prep, CvMat *R, CvMat *t,
					    parameter *newp)
{
  CvMat *preR = cvCreateMat(3, 3, CV_32F);
  CvMat *pret = cvCreateMat(3, 1, CV_32F);
  CvMat *newR = cvCreateMat(3, 3, CV_32F);
  CvMat *newt = cvCreateMat(3, 1, CV_32F);
  CvMat *tempt = cvCreateMat(3, 1, CV_32F);

  /*  prep  preR  pret Ɉڂ  */
  EulerXYZ2R(&(prep->tx), &(prep->ty), &(prep->tz), preR);
  cvmSet(pret, 0, 0, prep->x);
  cvmSet(pret, 1, 0, prep->y);
  cvmSet(pret, 2, 0, prep->z);

  /*
    x_1 = R_1 x_0 + t_1;
    x_2 = R_2 x_1 + t_2
        = R_2 (R_1 x_0 + t_1) + t_2
	= (R_2 R_1) x_0 + (R_2 t_1 + t_2)
  */
  cvmMul(R, preR, newR);
  cvmMul(R, pret, tempt);
  cvmAdd(tempt, t, newt);

  /*  newR  newt  newp Ɉڂ  */
  R2EulerXYZ(newR, &(newp->tx), &(newp->ty), &(newp->tz));
  newp->x = cvmGet(newt, 0, 0);
  newp->y = cvmGet(newt, 1, 0);
  newp->z = cvmGet(newt, 2, 0);
  
  cvReleaseMat(&preR);
  cvReleaseMat(&pret);
  cvReleaseMat(&newR);
  cvReleaseMat(&newt);
  cvReleaseMat(&tempt);
}

double calc_dist_points(point p1, point p2)
{
	double dist;

	dist = sqrt(pow((p1.x - p2.x),2.0) + pow((p1.y - p2.y),2.0) + pow((p1.z - p2.z),2.0));

	return dist;
}

/*  SVDpICP  */
/*  ϑ_Q Y  points[]Cf_Q X ͂̏ŌvZ  */
//#define ICP_SVD_THRESH	0.001
#define ICP_SVD_THRESH 0.005
double icp_svd(parameter *retp)
{
  parameter prep, newp;		/* Oƍ̃p[^ */
  double	preeval, neweval; /* Oƍ̕]li2拗j */
  point cp, mcp;		/* Ή_C܂łłƂ߂_ */
  int	i, j, k, minj;
  double	dist, min_dist;

  //fdS߂邽߂̃obt@
  point model_average;
  point vertex_average;
  double dist_line1, dist_line2;
  double surface_area;

  /* efʂ̏dS
  Ή_܂ł̃xNg߂邽߂̃obt@*/
  point datap_center[6];
  int datap_count[6];

  /*  for debug  */
  int	correspondence_count[6];/* ʂƂ̑Ή_̐Ď */
  double	distances[6];	/* ʂƂ̕ϋ */
    
  std::vector<int> selected_surface_num;/*I΂ꂽ*/
//  std::vector<double> surface_area_list;/*I΂ꂽʂ̖ʐ*/
//  std::vector<point> vertex_average_list;/*ʂ̏dS*/
  double surface_area_sum;

  prep = *retp;			/* p[^̐ݒ */

  preeval = evaluate(retp);	/* ]l̊l */

  /*  solve_RT ̕Ԃl錾  */
  CvMat *R = cvCreateMat(3, 3, CV_32F);
  CvMat *t = cvCreateMat(3, 1, CV_32F);

#ifdef PRINT_POINTS_CORRESPONDENCE
    std::ofstream fout;
	std::ofstream fout2;
	std::ofstream fout3;

	char filename_corresp_d[MAXCHARS];
	char filename_corresp_m[MAXCHARS];
	char filename_corresp_m2[MAXCHARS];

	sprintf_s(filename_corresp_d, MAXCHARS, "correspondence_data%04d.txt", correspid);
	sprintf_s(filename_corresp_m, MAXCHARS, "correspondence_model%04d.txt", correspid);
	sprintf_s(filename_corresp_m2, MAXCHARS, "similer_direction%04d.txt", correspid);

	printf_s("%s\n",filename_corresp_d);
	printf_s("%s\n",filename_corresp_m);
	printf_s("%s\n",filename_corresp_m2);

	fout.open(filename_corresp_d, std::ios::out);  
	fout2.open(filename_corresp_m, std::ios::out);
	fout3.open(filename_corresp_m2, std::ios::out);

#endif
  
  while (1)
  {
	for (i = 0; i < 6; i++) correspondence_count[i] = 0;
	for (i = 0; i < 6; i++) distances[i] = 0.0;

	for (i = 0; i < 6; i++){

		datap_center[i].x = datap_center[i].y = datap_center[i].z = 0.0;
		datap_count[i] = 0;
	}

    /*  ݂̃p[^păfWϊ  */
    copy_polytope(modelpt, temppt);
    transform_polytope(temppt, prep.x, prep.y, prep.z, prep.tx, prep.ty, prep.tz);

    /*  Wϊfƃf[^_Ƃ̍ŋߖT_TɂΉ_  */
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;

    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */
		
		min_dist = VERY_LARGE;
		
		for (j = 0; j < temppt->polygon_num; j++)
		{
/* 
 *	 for (j = 2; j < 3; j++){
 */
			if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
					  temppt->polygons[j].nx, temppt->polygons[j].ny, temppt->polygons[j].nz))
			{
				
				datap_center[j].x += points[i].x;
				datap_center[j].y += points[i].y;
				datap_center[j].z += points[i].z;
				datap_count[j]++;

				dist = polygon_point_distance_with_correspondence(&(temppt->polygons[j]),
									&(points[i]), &cp);
#ifdef PRINT_POINTS_CORRESPONDENCE

				fout3 << points[i].x << ' ' << points[i].y << ' ' << points[i].z << std::endl;

#endif
				/*  cp ͑Ή_  */
				if (dist < min_dist)
				{
					min_dist = dist;
					minj = j;
					mcp = cp;
				}

			}
		}
		if (min_dist == VERY_LARGE){
			is_effective[i] = 0;
		}
		else{
			is_effective[i] = 1;
			mpoints[i] = mcp;		/* Ή_f[^ۑ */
			effective_point_num++;
			mp_model.x += mcp.x;
			mp_model.y += mcp.y;
			mp_model.z += mcp.z;
			mp_data.x += points[i].x;
			mp_data.y += points[i].y;
			mp_data.z += points[i].z;

			correspondence_count[minj]++;

			distances[minj] += min_dist;

			/*Ή_̑go*/
#ifdef PRINT_POINTS_CORRESPONDENCE
			fout << points[i].x << ' ' << points[i].y << ' ' << points[i].z << std::endl;	  
			fout2 << mcp.x << ' ' << mcp.y << ' ' << mcp.z << std::endl;	
#endif
		}
	}

    mp_model.x /= (double)effective_point_num;
    mp_model.y /= (double)effective_point_num;
    mp_model.z /= (double)effective_point_num;
    mp_data.x /= (double)effective_point_num;
    mp_data.y /= (double)effective_point_num;
    mp_data.z /= (double)effective_point_num;

	for(j = 0; j < 6; j++)
	{
		if(correspondence_count[j] != 0)
			distances[j] /= (double)correspondence_count[j];
		else
			distances[j] = 0.0;
	}

    fprintf(stderr, " Mean Point (Model) = (%f, %f, %f)\n",
	    mp_model.x, mp_model.y, mp_model.z);
    fprintf(stderr, " Mean Point (Data)  = (%f, %f, %f)\n",
	    mp_data.x, mp_data.y, mp_data.z);

    /*  for debug  */
    fprintf(stderr, "Corresp. Count-> [0: %d] [1: %d] [2: %d] [3: %d] [4: %d] [5: %d]\n",
	    correspondence_count[0],
	    correspondence_count[1],
	    correspondence_count[2],
	    correspondence_count[3],
	    correspondence_count[4],
	    correspondence_count[5]);
    fprintf(stderr, "Distances-> [0: %6.6f] [1: %6.6f] [2: %6.6f] [3: %6.6f] [4: %6.6f] [5: %6.6f]\n",
	    distances[0],
	    distances[1],
	    distances[2],
	    distances[3],
	    distances[4],
	    distances[5]);

	for(i = 0; i < 6; i++)
	{
		if(correspondence_count[i] != 0)
			selected_surface_num.push_back(i);
	}

    /*  ̑Ή_iX ɑjpĐVȃp[^vZ  */
    /*  mpoints ݂͌̃p[^ŃfWϊ̂̏̑Ή_iin ΍Wj*/
    solve_RT(point_num, points, mpoints, is_effective, R, t);

    /*  solve_RT ͍̃p[^Ԃ̂ŁCÕp[^Ɂ{KvD
	Iɂ́CϊsƕiړxNgێׂD*/
    compose_transformation_with_parameters(&prep, R, t, &newp);

    neweval = evaluate(&newp);

#ifdef OUTPUT_IMAGE
      output_scene_positions_to_image(0, newp.x, newp.y, newp.z,
				      newp.tx, newp.ty, newp.tz);
#endif
      
    /*  I𖞂甲Dp[^̕ωC邢͌덷̌  */
    fprintf(stderr, "Old Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    prep.x, prep.y, prep.z,
	    rad_to_deg(prep.tx), rad_to_deg(prep.ty), rad_to_deg(prep.tz));
    fprintf(stderr, "   (eval = %f)\n", preeval);
    
    fprintf(stderr, "New Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    newp.x, newp.y, newp.z,
	    rad_to_deg(newp.tx), rad_to_deg(newp.ty), rad_to_deg(newp.tz));
    fprintf(stderr, "   (eval = %f)\n", neweval);
    
	//O萄̕]l悩ۑ
	if(neweval < vest_param.estimate_error)
	{
		vest_param.estimate_error = neweval;

		vest_param.pose.position.x = newp.x;
		vest_param.pose.position.y = newp.y;
		vest_param.pose.position.z = newp.z;
		vest_param.pose.orientation.r = newp.tx;
		vest_param.pose.orientation.p = newp.ty;
		vest_param.pose.orientation.y = newp.tz;

		vest_param.evaluate_value = 0.0;

		//fdS߂D
		//dSFeӂsp̏d݂
		//ʐρF0̒~1̒

		model_average.x = model_average.y = model_average.z = 0.0;
		vertex_average.x = vertex_average.y = vertex_average.z = 0.0;
		surface_area_sum = 0.0;

		point temp_vertex_average;
		temp_vertex_average.x = temp_vertex_average.y = temp_vertex_average.z = 0.0;

		for(i = 0; i < selected_surface_num.size(); i++)
		{
			for(j = 0; j < temppt->polygons[selected_surface_num[i]].line_num; j++)
			{
				vertex_average.x += temppt->polygons[selected_surface_num[i]].lines[j].sp.x;
				vertex_average.y += temppt->polygons[selected_surface_num[i]].lines[j].sp.y;
				vertex_average.z += temppt->polygons[selected_surface_num[i]].lines[j].sp.z;
			}
			vertex_average.x /= 4.0;
			vertex_average.y /= 4.0;
			vertex_average.z /= 4.0;

			dist_line1 = distance(temppt->polygons[selected_surface_num[i]].lines[0].sp, 
				temppt->polygons[selected_surface_num[i]].lines[0].ep);
			dist_line2 = distance(temppt->polygons[selected_surface_num[i]].lines[1].sp, 
				temppt->polygons[selected_surface_num[i]].lines[1].ep);

			surface_area = dist_line1 * dist_line2;
			printf("surface_area %d : %f\n", i, surface_area);


			model_average.x += surface_area * vertex_average.x;
			model_average.y += surface_area * vertex_average.y;
			model_average.z += surface_area * vertex_average.z;

			temp_vertex_average.x += vertex_average.x;
			temp_vertex_average.y += vertex_average.y;
			temp_vertex_average.z += vertex_average.z;

			surface_area_sum += surface_area;

		}
		model_average.x /= surface_area_sum;
		model_average.y /= surface_area_sum;
		model_average.z /= surface_area_sum;

		temp_vertex_average.x /= selected_surface_num.size();
		temp_vertex_average.y /= selected_surface_num.size();
		temp_vertex_average.z /= selected_surface_num.size();

		printf("data_average:(%f %f %f)\n",data_average.x, data_average.y, data_average.z);
		printf("vertex_average:(%f %f %f)\n",temp_vertex_average.x, temp_vertex_average.y, temp_vertex_average.z);
		printf("model_average:(%f %f %f)\n",model_average.x, model_average.y, model_average.z);
		printf("dist_between_vertex_data:%f\n",distance(data_average, temp_vertex_average));
		printf("effective_point_num:%d\n",effective_point_num);

		correspondence_of_vestp = effective_point_num;

		double tempdist;

		/*eʂɓef[^_̏dSƃfʂ̏dS̋߂*/
		for(i = 0; i < 6; i++)
		{
			if(correspondence_count[i] != 0)
			{	
				vertex_average.x = vertex_average.y = vertex_average.z = 0.0;

				//eʂƓ@̓_Q̏dSo
				datap_center[i].x /= datap_count[i];
				datap_center[i].y /= datap_count[i];
				datap_center[i].z /= datap_count[i];

				printf("datap_center[%d] = (%f, %f, %f)\n",i ,datap_center[i].x ,datap_center[i].y ,datap_center[i].z);
				
				/*fʂ̏dS*/
				for(j = 0; j < temppt->polygons[i].line_num; j++)
				{
					vertex_average.x += temppt->polygons[i].lines[j].sp.x;
					vertex_average.y += temppt->polygons[i].lines[j].sp.y;
					vertex_average.z += temppt->polygons[i].lines[j].sp.z;
				}

				vertex_average.x /= 4.0;
				vertex_average.y /= 4.0;
				vertex_average.z /= 4.0;

				printf("vertex_average[%d] = (%f, %f, %f)\n",i ,vertex_average.x, vertex_average.y, vertex_average.z);

				tempdist = distance(datap_center[i], vertex_average);

				printf("distance[%d] = %f\n",i ,tempdist);

				vest_param.evaluate_value += tempdist;
			}
		}
		
		printf("evaluate_value:%f\n",vest_param.evaluate_value);

	}
/* 
 *     printf("ok ? ");
 *     getchar();
 */

/* 
 *     double diff = sqrt(sqr(prep.x-newp.x) + sqr(prep.y-newp.y) + sqr(prep.z-newp.z));
 */
    double diff = fabs(preeval - neweval);
    if (diff < ICP_SVD_THRESH){
      *retp = newp;
      break;
    }
/* 
 *     if (neweval < ICP_SVD_THRESH){
 *	 *retp = newp;
 *	 break;
 *     }
 */

    /*  Õp[^C]lޔ  */
    prep = newp;
    preeval = neweval;
  }

  //distances̒ōł傫̂i[

  double biggest_distance = -9999.0;

  for(i = 0; i < 6; i++)
  {
	if(biggest_distance < distances[i])
		biggest_distance = distances[i]; 
  }
  printf("BiggestDistance : %6.6f\n",biggest_distance);

#ifdef PRINT_POINTS_CORRESPONDENCE	  
	fout.close();  
	fout2.close();
	fout3.close();
#endif
  return neweval;
}

/*-----------------------------------------------------*/
/*  routines for qsort, should be define somewhere     */ 
/*-----------------------------------------------------*/
/* 
 * static int intcompare(int i1, int i2)
 * {
 *   if (i1 > i2) return(1);
 *   else if (i1 < i2) return(-1);
 *   else return(0);
 * }
 * 
 * static int doublecompare(double i1, double i2)
 * {
 *   if (i1 > i2) return(1);
 *   else if (i1 < i2) return(-1);
 *   else return(0);
 * }
 */

/*  SVDpICPi2j  */
/*  ϑ_Q Y  points[]Cf_Q X ͂̏ŌvZ  */
/*  ʑ̂̏ꍇ́CƂ덷̑傫Ƃ납獇킹čsH  */
#define ICP_SVD2_THRESH	0.005
#define SELECT_FARTHEST_SURFACE
#define MAX_ITERATION	6
#define MINIMUM_CORRESPONDENCE_NUM	10
double icp_svd2(parameter *retp)
{
  parameter prep, newp;		/* Oƍ̃p[^ */
  double	preeval, neweval; /* Oƍ̕]li2拗j */
  point cp, mcp;		/* Ή_C܂łłƂ߂_ */
  int	i, j, k, minj, maxj, maxcount;
  double	dist, min_dist, max_dist;

  int	min_selected_count;
  int	iteration_num;

  int	correspondence_count[6];/* ʂƂ̑Ή_̐Ď */
  double	distances[6];	/* ʂƂ̕ϋ */
  int	selected_count[6];	/* ʂƂ̑I΂ꂽ */
  
  std::vector<int> selected_surface_num;/*I΂ꂽ*/
    
  prep = *retp;			/* p[^̐ݒ */

  preeval = evaluate(retp);	/* ]l̊l */

  //fdS߂邽߂̃obt@
  point model_average;
  point vertex_average;
  double dist_line1, dist_line2;
  double surface_area;
  double surface_area_sum;

  /*  solve_RT ̕Ԃl錾  */
  CvMat *R = cvCreateMat(3, 3, CV_32F);
  CvMat *t = cvCreateMat(3, 1, CV_32F);

  iteration_num = 0;

#ifdef PRINT_POINTS_CORRESPONDENCE
    std::ofstream fout;
	std::ofstream fout2;
	char filename_corresp_d[MAXCHARS];
	char filename_corresp_m[MAXCHARS];

	sprintf_s(filename_corresp_d, MAXCHARS, "correspondence_data%04d.txt", correspid);
	sprintf_s(filename_corresp_m, MAXCHARS, "correspondence_model%04d.txt", correspid);

	printf_s("%s\n",filename_corresp_d);
	printf_s("%s\n",filename_corresp_m);

	fout.open(filename_corresp_d, std::ios::out);  
	fout2.open(filename_corresp_m, std::ios::out);

#endif

  while (1){
   for (i = 0; i < 6; i++) correspondence_count[i] = 0;
   for (i = 0; i < 6; i++) distances[i] = 0.0;
   for (i = 0; i < 6; i++) selected_count[i] = 0;

//   for (i = 0; i < 6; i++) corresp_center[i].x = corresp_center[i].y = corresp_center[i].z = 0.0;

   /*  ݂̃p[^păfWϊ  */
    copy_polytope(modelpt, temppt);
    transform_polytope(temppt, prep.x, prep.y, prep.z, prep.tx, prep.ty, prep.tz);

    /*  Wϊfƃf[^_Ƃ̍ŋߖT_TɂΉ_  */
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;
    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */
      min_dist = VERY_LARGE;
      for (j = 0; j < temppt->polygon_num; j++){
/* 
 *	 for (j = 2; j < 3; j++){
 */
		if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
				      temppt->polygons[j].nx,
				      temppt->polygons[j].ny,
				      temppt->polygons[j].nz)){
/* 
 *	     fprintf(stderr, "point[%d] faces the same direction with surface-2\n", i);
 */
	  
		  dist = polygon_point_distance_with_correspondence(&(temppt->polygons[j]),
							    &(points[i]), &cp);
	  /*  cp ͑Ή_  */

		  if (dist < min_dist){		 
			min_dist = dist;
			minj = j;
			mcp = cp;	
		  }	
		}
	  }
	  if (min_dist == VERY_LARGE){
		is_effective[i] = 0;
		corresponding_surface[i] = NO_MATCH;
      }
      else{
		is_effective[i] = 1;
		mpoints[i] = mcp;		/* Ή_f[^ۑ */
	
		/*  ꕔ̖ʂgȂ̂ł΁C͕̕svD */
		effective_point_num++;
		mp_model.x += mcp.x;
		mp_model.y += mcp.y;
		mp_model.z += mcp.z;
		mp_data.x += points[i].x;
		mp_data.y += points[i].y;
		mp_data.z += points[i].z;
		/*  ꕔ̖ʂgȂ̂ł΁C͕̕svD */

		correspondence_count[minj]++;
		corresponding_surface[i] = minj;
		distances[minj] += min_dist;

#ifdef PRINT_POINTS_CORRESPONDENCE
			fout << points[i].x << ' ' << points[i].y << ' ' << points[i].z << std::endl;	  
			fout2 << mcp.x << ' ' << mcp.y << ' ' << mcp.z << std::endl;	
#endif
	  }
	}

    /*  MINIMUM_CORRESPONDENCE_NUM 𒴂鐔̑Ήʂ̂C
	̃Ehł܂I΂ĂȂ̂́CI΂ꂽ񐔂߂D
	𒴂Ă͍̂͑I΂ȂD*/
    min_selected_count = VERY_LARGE_INT;
    for (j = 0; j < 6; j++){
      if (correspondence_count[j] >= MINIMUM_CORRESPONDENCE_NUM){
		  min_selected_count = min(min_selected_count, selected_count[j]);
      }
    }

#ifdef SELECT_FARTHEST_SURFACE
    max_dist = VERY_SMALL;

		for (j = 0; j < 6; j++){
			distances[j] /= (double)correspondence_count[j];
			
			if ((j != previous_selected_surface) && (distances[j] > max_dist)){
	/* 
	 *	 if ((selected_count[j] == min_selected_count) && (distances[j] > max_dist)){
	 */
			  maxj = j;
			  max_dist = distances[j];
			  selected_count[maxj]++;
			}
		}
#else
    maxcount = VERY_SMALL_INT;
    for (j = 0; j < 6; j++){
		if ((j != previous_selected_surface) && (correspondence_count[j] > maxcount)){
/* 
 *	 if ((selected_count[j] == min_selected_count) && (correspondence_count[j] > maxcount)){
 */
			maxj = j;
			maxcount = correspondence_count[j];
			selected_count[maxj]++;
      }
    }
#endif
    
    /*  for debug  */
    fprintf(stderr, "Corresp. Count-> [0: %d] [1: %d] [2: %d] [3: %d] [4: %d] [5: %d]\n",
	    correspondence_count[0],
	    correspondence_count[1],
	    correspondence_count[2],
	    correspondence_count[3],
	    correspondence_count[4],
	    correspondence_count[5]);
    fprintf(stderr, "Distances-> [0: %6.6f] [1: %6.6f] [2: %6.6f] [3: %6.6f] [4: %6.6f] [5: %6.6f]\n",
	    distances[0],
	    distances[1],
	    distances[2],
	    distances[3],
	    distances[4],
	    distances[5]);

    fprintf(stderr, " ==> Select Surface %d\n", maxj);
    
    previous_selected_surface = maxj;
	
	for(i = 0; i < 6; i++)
	{
		if(correspondence_count[i] != 0)
			selected_surface_num.push_back(i);
	}

#ifdef SELECT_FARTHEST_SURFACE
    /*  Ƃ̑傫ʂIC̃f[^gē_╽ψʒuvZD*/
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;

    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */     
		if (is_effective[i]){	     /* Ή_ */
		  if (corresponding_surface[i] == maxj){ /* Ήʂ maxj ł */
			  mp_model.x += mpoints[i].x;
			  mp_model.y += mpoints[i].y;	
			  mp_model.z += mpoints[i].z;
			  mp_data.x += points[i].x;
			  mp_data.y += points[i].y;
			  mp_data.z += points[i].z;
			  effective_point_num++;

		  }
		  else{
			  is_effective[i] = 0;	/* vZɂ͎gȂ */
		  }
		}
	}
#else
    /*  ƂΉ_̑ʂIC̃f[^gē_╽ψʒuvZD*/
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;
    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */
      if (is_effective[i]){	     /* Ή_ */
	if (corresponding_surface[i] == maxj){ /* Ήʂ maxj ł */
	  mp_model.x += mpoints[i].x;
	  mp_model.y += mpoints[i].y;
	  mp_model.z += mpoints[i].z;
	  mp_data.x += points[i].x;
	  mp_data.y += points[i].y;
	  mp_data.z += points[i].z;
	  effective_point_num++;
	}
	else{
	  is_effective[i] = 0;	/* vZɂ͎gȂ */
	}
      }
    }
#endif
    
    mp_model.x /= (double)effective_point_num;
    mp_model.y /= (double)effective_point_num;
    mp_model.z /= (double)effective_point_num;
    mp_data.x /= (double)effective_point_num;
    mp_data.y /= (double)effective_point_num;
    mp_data.z /= (double)effective_point_num;

    fprintf(stderr, " Mean Point (Model) = (%f, %f, %f)\n",
	    mp_model.x, mp_model.y, mp_model.z);
    fprintf(stderr, " Mean Point (Data)  = (%f, %f, %f)\n",
	    mp_data.x, mp_data.y, mp_data.z);

    /*  ̑Ή_iX ɑjpĐVȃp[^vZ  */
    /*  mpoints ݂͌̃p[^ŃfWϊ̂̏̑Ή_iin ΍Wj*/
    solve_RT(point_num, points, mpoints, is_effective, R, t);

    /*  solve_RT ͍̃p[^Ԃ̂ŁCÕp[^Ɂ{KvD
	Iɂ́CϊsƕiړxNgێׂD*/
/* 
 *     compose_transformation_with_parameters(preR, pret, deltaR, deltat, newR, newt);
 */
    compose_transformation_with_parameters(&prep, R, t, &newp);

    neweval = evaluate(&newp);

#ifdef OUTPUT_IMAGE
      output_scene_positions_to_image(0, newp.x, newp.y, newp.z,
				      newp.tx, newp.ty, newp.tz);
#endif
      
    /*  I𖞂甲Dp[^̕ωC邢͌덷̌  */
    fprintf(stderr, "Old Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    prep.x, prep.y, prep.z,
	    rad_to_deg(prep.tx), rad_to_deg(prep.ty), rad_to_deg(prep.tz));
    fprintf(stderr, "   (eval = %f)\n", preeval);
    
    fprintf(stderr, "New Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    newp.x, newp.y, newp.z,
	    rad_to_deg(newp.tx), rad_to_deg(newp.ty), rad_to_deg(newp.tz));
    fprintf(stderr, "   (eval = %f)\n", neweval);
   
/* 
 *     printf("ok ? ");
 *     getchar();
 */

/* 
 *     double diff = sqrt(sqr(prep.x-newp.x) + sqr(prep.y-newp.y) + sqr(prep.z-newp.z));
 *     if (diff < ICP_SVD2_THRESH){
 *	 break;
 *     }
 */
    if (neweval < ICP_SVD2_THRESH){
      *retp = newp;
      break;
    }
    else if (iteration_num == MAX_ITERATION){
      *retp = newp;
      break;
    }

    iteration_num++;
    
    /*  Õp[^C]lޔ  */
    prep = newp;
    preeval = neweval;
  }

  fprintf(stderr, " Exit icp_svd2 \n");
  
#ifdef PRINT_POINTS_CORRESPONDENCE	  
	fout.close();  
	fout2.close();
#endif
  return neweval;
}

//~̐
//ׂĂ̖ʂ킹
double icp_svd_cylinder(parameter *retp)
{
  parameter prep, newp;		/* Oƍ̃p[^ */
  double	preeval, neweval; /* Oƍ̕]li2拗j */
  point cp, mcp;		/* Ή_C܂łłƂ߂_ */
  int	i, j, minj, maxj;
  double	dist, min_dist, max_dist;

  /*  for debug  */
  int	correspondence_count[3];/* ʂƂ̑Ή_̐D~Ȃ̂3 */
  double distances[3];	/*ʂƂ̕ϋ*/
  prep = *retp;			/* p[^̐ݒ */
 
  similar_side = 0;
  preeval = evaluate_disk(retp);	/* ]l̊l */

//  printf("similar_side:%d\n",similar_side);
//  getchar();

  /*  solve_RT ̕Ԃl錾  */
  CvMat *R = cvCreateMat(3, 3, CV_32F);
  CvMat *t = cvCreateMat(3, 1, CV_32F);

#ifdef PRINT_POINTS_CORRESPONDENCE
    std::ofstream fout;
	std::ofstream fout2;
	char filename_corresp_d[MAXCHARS];
	char filename_corresp_m[MAXCHARS];

	sprintf_s(filename_corresp_d, MAXCHARS, "correspondence_data%04d.txt", correspid);
	sprintf_s(filename_corresp_m, MAXCHARS, "correspondence_model%04d.txt", correspid);

	printf_s("%s\n",filename_corresp_d);
	printf_s("%s\n",filename_corresp_m);

	fout.open(filename_corresp_d, std::ios::out);  
	fout2.open(filename_corresp_m, std::ios::out);

#endif
  
  while (1){
  for (i = 0; i < 3; i++) correspondence_count[i] = 0;
  for (i = 0; i < 3; i++) distances[i] = 0.0;

    /*  ݂̃p[^păfWϊ  */
	copy_cylinder(modelcy, tempcy);
	transform_cylinder(tempcy, prep.x, prep.y, prep.z, prep.tx, prep.ty, prep.tz);

    /*  Wϊfƃf[^_Ƃ̍ŋߖT_TɂΉ_  */
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;


    similar_side_cp = 0;

    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */

		min_dist = VERY_LARGE;
      for (j = 0; j < 2; j++){
/* 
 *	 for (j = 2; j < 3; j++){
 */
		if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
			tempcy->disks[j].nx, tempcy->disks[j].ny, tempcy->disks[j].nz)){

			dist = disk_point_distance_with_correspondence(&(tempcy->disks[j]),&(points[i]), &cp);
			/*  cp ͑Ή_  */

			if (dist < min_dist){
				min_dist = dist;
				minj = j;
				mcp = cp;
			}
		}
		else
		{
			if(check_inside_model(&(points[i]), tempcy))
			{
			//_̈ʒu~̏ʂƒʂɂ͂܂Ă
			//YWiZTWnɂ鉔jɊւĂ͂܂Ă邩

				dist = side_point_distance_with_correspondence(tempcy, &(points[i]), &cp);

				if (dist < min_dist){
					min_dist = dist;
					minj = 2;
					mcp = cp;
				}
			}
		}
      }
      if (min_dist == VERY_LARGE){
			is_effective[i] = 0;
			corresponding_surface[i] = NO_MATCH;
      }
      else{
			is_effective[i] = 1;
			mpoints[i] = mcp;		/* Ή_f[^ۑ */
			effective_point_num++;
			mp_model.x += mcp.x;
			mp_model.y += mcp.y;
			mp_model.z += mcp.z;
			mp_data.x += points[i].x;
			mp_data.y += points[i].y;
			mp_data.z += points[i].z;

			correspondence_count[minj]++;
			distances[minj] += min_dist;

			corresponding_surface[i] = minj;

#ifdef PRINT_POINTS_CORRESPONDENCE
			fout << points[i].x << ' ' << points[i].y << ' ' << points[i].z << std::endl;	  
			fout2 << mcp.x << ' ' << mcp.y << ' ' << mcp.z << std::endl;	
#endif
      }
	}

    /*  for debug  */
	fprintf(stderr, "Corresp. Count-> [0: %d] [1: %d] [2: %d]\n",
	    correspondence_count[0],
	    correspondence_count[1],
		correspondence_count[2]);

    for (j = 0; j < 3; j++){
		
		if(correspondence_count[j] != 0)
			distances[j] /= (double)correspondence_count[j];
		else
			distances[j] = VERY_SMALL;
      
	}	
	
	fprintf(stderr, "Distances->[0: %6.6f] [1: %6.6f] [2:%6.6f]",
		distances[0], distances[1], distances[2]);

    mp_model.x /= (double)effective_point_num;
    mp_model.y /= (double)effective_point_num;
    mp_model.z /= (double)effective_point_num;
    mp_data.x /= (double)effective_point_num;
    mp_data.y /= (double)effective_point_num;
    mp_data.z /= (double)effective_point_num;

    fprintf(stderr, " Mean Point (Model) = (%f, %f, %f)\n",
	    mp_model.x, mp_model.y, mp_model.z);
    fprintf(stderr, " Mean Point (Data)  = (%f, %f, %f)\n",
	    mp_data.x, mp_data.y, mp_data.z);
    
    /*  ̑Ή_iX ɑjpĐVȃp[^vZ  */
    /*  mpoints ݂͌̃p[^ŃfWϊ̂̏̑Ή_iin ΍Wj*/
    solve_RT(point_num, points, mpoints, is_effective, R, t);

    /*  solve_RT ͍̃p[^Ԃ̂ŁCÕp[^Ɂ{KvD
	Iɂ́CϊsƕiړxNgێׂD*/
/* 
 *     compose_transformation_with_parameters(preR, pret, deltaR, deltat, newR, newt);
 */
    compose_transformation_with_parameters(&prep, R, t, &newp);

	similar_side = 0;
    neweval = evaluate_disk(&newp);
//	printf("similar_side:%d\n",similar_side);
//	getchar();


#ifdef OUTPUT_IMAGE
      output_scene_positions_to_image_cylinder(0, newp.x, newp.y, newp.z,
				      newp.tx, newp.ty, newp.tz);
#endif
      
    /*  I𖞂甲Dp[^̕ωC邢͌덷̌  */
    fprintf(stderr, "Old Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    prep.x, prep.y, prep.z,
	    rad_to_deg(prep.tx), rad_to_deg(prep.ty), rad_to_deg(prep.tz));
    fprintf(stderr, "   (eval = %f)\n", preeval);
    
    fprintf(stderr, "New Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    newp.x, newp.y, newp.z,
	    rad_to_deg(newp.tx), rad_to_deg(newp.ty), rad_to_deg(newp.tz));
    fprintf(stderr, "   (eval = %f)\n", neweval);
    
	//O萄̕]l悩ۑ
	if(neweval < vest_param.estimate_error)
	{
		vest_param.estimate_error = neweval;

		vest_param.pose.position.x = newp.x;
		vest_param.pose.position.y = newp.y;
		vest_param.pose.position.z = newp.z;
		vest_param.pose.orientation.r = newp.tx;
		vest_param.pose.orientation.p = newp.ty;
		vest_param.pose.orientation.y = newp.tz;

		printf("side_effective_point_num:%d\n",side_correspondence_count);

		correspondence_of_vestp = effective_point_num;

		vest_param.side_correspondence_rate = side_correspondence_rate;

		printf("vest_side_correspondence_rate:%.6f",side_correspondence_rate);
	}
/* 
 *     printf("ok ? ");
 *     getchar();
 */

/* 
 *     double diff = sqrt(sqr(prep.x-newp.x) + sqr(prep.y-newp.y) + sqr(prep.z-newp.z));
 */
    double diff = fabs(preeval - neweval);
    if (diff < ICP_SVD_THRESH){
      *retp = newp;
      break;
    }
/* 
 *     if (neweval < ICP_SVD_THRESH){
 *	 *retp = newp;
 *	 break;
 *     }
 */

    /*  Õp[^C]lޔ  */
    prep = newp;
    preeval = neweval;
  }
#ifdef PRINT_POINTS_CORRESPONDENCE
			fout.close();	  
			fout2.close();	
#endif
  correspid++;

  return neweval;
}

//~̐
//Ăʂ炠킹
double icp_svd_cylinder2(parameter *retp)
{
  parameter prep, newp;		/* Oƍ̃p[^ */
  double	preeval, neweval; /* Oƍ̕]li2拗j */
  point cp, mcp;		/* Ή_C܂łłƂ߂_ */
  int	i, j, minj, maxj;
  double	dist, min_dist, max_dist;
  int iteration_num;

  /*  for debug  */
  int	correspondence_count[3];/* ʂƂ̑Ή_̐D~Ȃ̂3 */
  double distances[3];	/*ʂƂ̕ϋ*/
  prep = *retp;			/* p[^̐ݒ */
 
  iteration_num = 0;
  similar_side = 0;
  preeval = evaluate_disk(retp);	/* ]l̊l */

  /*  solve_RT ̕Ԃl錾  */
  CvMat *R = cvCreateMat(3, 3, CV_32F);
  CvMat *t = cvCreateMat(3, 1, CV_32F);

  #ifdef PRINT_POINTS_CORRESPONDENCE
    std::ofstream fout;
	std::ofstream fout2;
	std::ofstream foutdist;
	char filename_corresp_d[MAXCHARS];
	char filename_corresp_m[MAXCHARS];
	char filename_dist[MAXCHARS];

	sprintf_s(filename_corresp_d, MAXCHARS, "correspondence_data%04d.txt", correspid);
	sprintf_s(filename_corresp_m, MAXCHARS, "correspondence_model%04d.txt", correspid);
	sprintf_s(filename_dist, MAXCHARS, "distance%04d.txt", correspid);

	printf_s("%s\n",filename_corresp_d);
	printf_s("%s\n",filename_corresp_m);
	printf_s("%s\n",filename_dist);

	fout.open(filename_corresp_d, std::ios::out);  
	fout2.open(filename_corresp_m, std::ios::out);
	foutdist.open(filename_dist, std::ios::out);

#endif
  
  while (1){
  for (i = 0; i < 3; i++) correspondence_count[i] = 0;
  for (i = 0; i < 3; i++) distances[i] = 0.0;

    /*  ݂̃p[^păfWϊ  */
	copy_cylinder(modelcy, tempcy);
	transform_cylinder(tempcy, prep.x, prep.y, prep.z, prep.tx, prep.ty, prep.tz);

    /*  Wϊfƃf[^_Ƃ̍ŋߖT_TɂΉ_  */
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;


    similar_side_cp = 0;

    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */

		min_dist = VERY_LARGE;
      for (j = 0; j < 2; j++){

		if (similar_direction(points[i].nx, points[i].ny, points[i].nz,
			tempcy->disks[j].nx, tempcy->disks[j].ny, tempcy->disks[j].nz)){

			dist = disk_point_distance_with_correspondence(&(tempcy->disks[j]),&(points[i]), &cp);
			/*  cp ͑Ή_  */

			if (dist < min_dist){
				min_dist = dist;
				minj = j;
				mcp = cp;
			}
		}
		else
		{
			if(check_inside_model(&(points[i]), tempcy))
			{
			//_̈ʒu~̏ʂƒʂɂ͂܂Ă
			//YWiZTWnɂ鉔jɊւĂ͂܂Ă邩
				dist = side_point_distance_with_correspondence(tempcy, &(points[i]), &cp);

				if (dist < min_dist){
					min_dist = dist;
					minj = 2;
					mcp = cp;
				}
			}
		}
      }
      if (min_dist == VERY_LARGE){
			is_effective[i] = 0;
			corresponding_surface[i] = NO_MATCH;
      }
      else{
			is_effective[i] = 1;
			mpoints[i] = mcp;		/* Ή_f[^ۑ */
			effective_point_num++;
			mp_model.x += mcp.x;
			mp_model.y += mcp.y;
			mp_model.z += mcp.z;
			mp_data.x += points[i].x;
			mp_data.y += points[i].y;
			mp_data.z += points[i].z;

			correspondence_count[minj]++;
			distances[minj] += min_dist;

			corresponding_surface[i] = minj;
#ifdef PRINT_POINTS_CORRESPONDENCE
			fout << points[i].x << ' ' << points[i].y << ' ' << points[i].z << std::endl;	  
			fout2 << mcp.x << ' ' << mcp.y << ' ' << mcp.z << std::endl;	
			foutdist << min_dist << std::endl;
#endif
      }
	}

    /*  for debug  */
	fprintf(stderr, "Corresp. Count-> [0: %d] [1: %d] [2: %d]\n",
	    correspondence_count[0],
	    correspondence_count[1],
		correspondence_count[2]);

#ifdef SELECT_FARTHEST_SURFACE
    max_dist = VERY_SMALL;
	fprintf(stderr,"previous_selected_surface:%d\n",previous_selected_surface);
    for (j = 0; j < 3; j++){
		
		if(correspondence_count[j] != 0)
			distances[j] /= (double)correspondence_count[j];
		else
			distances[j] = VERY_SMALL;

		if ((j != previous_selected_surface) && (distances[j] > max_dist)){

		  maxj = j;
		  max_dist = distances[j];
      }
    }	
	
	fprintf(stderr, "Distances->[0: %6.6f] [1: %6.6f] [2:%6.6f]",
		distances[0], distances[1], distances[2]);

    fprintf(stderr, " ==> Select Surface %d\n", maxj);
    
    previous_selected_surface = maxj;

	/*  Ƃ̑傫ʂIC̃f[^gē_╽ψʒuvZD*/
    effective_point_num = 0;
    mp_model.x = mp_model.y = mp_model.z = 0.0;
    mp_data.x = mp_data.y = mp_data.z = 0.0;
    for (i = 0; i < point_num; i++){ /* f[^_ƂɑΉ_T */     
		if (is_effective[i]){	     /* Ή_ */
		  if (corresponding_surface[i] == maxj){ /* Ήʂ maxj ł */
			  mp_model.x += mpoints[i].x;
			  mp_model.y += mpoints[i].y;	
			  mp_model.z += mpoints[i].z;
			  mp_data.x += points[i].x;
			  mp_data.y += points[i].y;
			  mp_data.z += points[i].z;
			  effective_point_num++;
		  }
		  else{
			  is_effective[i] = 0;	/* vZɂ͎gȂ */
		  }
		}
	}
#endif

//	printf("similar_side_cp:%d\n",similar_side_cp);

    fprintf(stderr, " Mean Point (Model) = (%f, %f, %f)\n",
	    mp_model.x, mp_model.y, mp_model.z);
    fprintf(stderr, " Mean Point (Data)  = (%f, %f, %f)\n",
	    mp_data.x, mp_data.y, mp_data.z);

	fprintf(stderr, " Effective Point Num = %d\n",effective_point_num);

    mp_model.x /= (double)effective_point_num;
    mp_model.y /= (double)effective_point_num;
    mp_model.z /= (double)effective_point_num;
    mp_data.x /= (double)effective_point_num;
    mp_data.y /= (double)effective_point_num;
    mp_data.z /= (double)effective_point_num;

    fprintf(stderr, " Mean Point (Model) = (%f, %f, %f)\n",
	    mp_model.x, mp_model.y, mp_model.z);
    fprintf(stderr, " Mean Point (Data)  = (%f, %f, %f)\n",
	    mp_data.x, mp_data.y, mp_data.z);
    
    /*  ̑Ή_iX ɑjpĐVȃp[^vZ  */
    /*  mpoints ݂͌̃p[^ŃfWϊ̂̏̑Ή_iin ΍Wj*/
    solve_RT(point_num, points, mpoints, is_effective, R, t);

    /*  solve_RT ͍̃p[^Ԃ̂ŁCÕp[^Ɂ{KvD
	Iɂ́CϊsƕiړxNgێׂD*/
/* 
 *     compose_transformation_with_parameters(preR, pret, deltaR, deltat, newR, newt);
 */
    compose_transformation_with_parameters(&prep, R, t, &newp);

	similar_side = 0;
    neweval = evaluate_disk(&newp);
//	printf("similar_side:%d\n",similar_side);
//	getchar();


#ifdef OUTPUT_IMAGE
      output_scene_positions_to_image_cylinder(0, newp.x, newp.y, newp.z,
				      newp.tx, newp.ty, newp.tz);
#endif
      
    /*  I𖞂甲Dp[^̕ωC邢͌덷̌  */
    fprintf(stderr, "Old Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    prep.x, prep.y, prep.z,
	    rad_to_deg(prep.tx), rad_to_deg(prep.ty), rad_to_deg(prep.tz));
    fprintf(stderr, "   (eval = %f)\n", preeval);
    
    fprintf(stderr, "New Parameter = Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	    newp.x, newp.y, newp.z,
	    rad_to_deg(newp.tx), rad_to_deg(newp.ty), rad_to_deg(newp.tz));
    fprintf(stderr, "   (eval = %f)\n", neweval);
    
/* 
 *     printf("ok ? ");
 *     getchar();
 */

/* 
 *     double diff = sqrt(sqr(prep.x-newp.x) + sqr(prep.y-newp.y) + sqr(prep.z-newp.z));
 */
    double diff = fabs(preeval - neweval);
    if (diff < ICP_SVD_THRESH){
      *retp = newp;
      break;
    }
	else if(iteration_num == MAX_ITERATION){
	  *retp = newp;
	  break;
	}

	iteration_num++;
/* 
 *     if (neweval < ICP_SVD_THRESH){
 *	 *retp = newp;
 *	 break;
 *     }
 */

    /*  Õp[^C]lޔ  */
    prep = newp;
    preeval = neweval;
  }

#ifdef PRINT_POINTS_CORRESPONDENCE	  
	fout.close();  
	fout2.close();
	foutdist.close();
#endif

  correspid++;

  return neweval;
}

/************************************************  ICP using SVD  **************************************************/
/*
 * t@CɃf̒_o
 */
void output_scene_positions(char *filename,
			    double x, double y, double z,
			    double tx, double ty, double tz)
{
  FILE	*fp;
  errno_t	err;
  
  copy_polytope(modelpt, temppt);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  transform_polytope(temppt, x, y, z, tx, ty, tz);

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */

  if ((err = fopen_s(&fp, filename, "w")) != 0){
	  fprintf(stderr, "file %s cannot be opened.\n", filename);
	  exit(-1);	
  }
  
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[2].lines[0].sp.x, 
	 temppt->polygons[2].lines[0].sp.y, 
	 temppt->polygons[2].lines[0].sp.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[2].lines[0].ep.x, 
	 temppt->polygons[2].lines[0].ep.y, 
	 temppt->polygons[2].lines[0].ep.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[2].lines[2].sp.x, 
	 temppt->polygons[2].lines[2].sp.y, 
	 temppt->polygons[2].lines[2].sp.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[2].lines[2].ep.x, 
	 temppt->polygons[2].lines[2].ep.y, 
	 temppt->polygons[2].lines[2].ep.z);
  
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[5].lines[0].sp.x, 
	 temppt->polygons[5].lines[0].sp.y, 
	 temppt->polygons[5].lines[0].sp.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[5].lines[0].ep.x, 
	 temppt->polygons[5].lines[0].ep.y, 
	 temppt->polygons[5].lines[0].ep.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[5].lines[2].sp.x, 
	 temppt->polygons[5].lines[2].sp.y, 
	 temppt->polygons[5].lines[2].sp.z);
  fprintf(fp, "%f %f %f\n",
	 temppt->polygons[5].lines[2].ep.x, 
	 temppt->polygons[5].lines[2].ep.y, 
	 temppt->polygons[5].lines[2].ep.z);

  fclose(fp);
}

void output_scene_positions_cylinder(char *filename,
			    double x, double y, double z,
			    double tx, double ty, double tz)
{
  FILE	*fp;
  errno_t	err;
  
  copy_cylinder(modelcy, tempcy);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  transform_cylinder(tempcy, x, y, z, tx, ty, tz);

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */

  if ((err = fopen_s(&fp, filename, "w")) != 0){
	  fprintf(stderr, "file %s cannot be opened.\n", filename);
	  exit(-1);	
  }
  
  fprintf(fp, "%f %f %f\n",
	  tempcy->disks[0].center.x,
	  tempcy->disks[0].center.y,
	  tempcy->disks[0].center.z);
  fprintf(fp, "%f %f %f\n",
	  tempcy->disks[1].center.x,
	  tempcy->disks[1].center.y,
	  tempcy->disks[1].center.z);

  fclose(fp);
}

/*
 * ̗lq摜Ƃĕ\()
 */
void output_scene_positions_to_image(int is_initial,
				     double x, double y, double z,
				     double tx, double ty, double tz)
{
  point vertices[8];
  
  copy_polytope(modelpt, temppt);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  transform_polytope(temppt, x, y, z, tx, ty, tz);

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */
  vertices[0].x = temppt->polygons[2].lines[0].sp.x;
  vertices[0].y = temppt->polygons[2].lines[0].sp.y; 
  vertices[0].z = temppt->polygons[2].lines[0].sp.z;

  vertices[1].x = temppt->polygons[2].lines[0].ep.x; 
  vertices[1].y = temppt->polygons[2].lines[0].ep.y; 
  vertices[1].z = temppt->polygons[2].lines[0].ep.z;

  vertices[2].x = temppt->polygons[2].lines[2].sp.x; 
  vertices[2].y = temppt->polygons[2].lines[2].sp.y; 
  vertices[2].z = temppt->polygons[2].lines[2].sp.z;

  vertices[3].x = temppt->polygons[2].lines[2].ep.x; 
  vertices[3].y = temppt->polygons[2].lines[2].ep.y; 
  vertices[3].z = temppt->polygons[2].lines[2].ep.z;

  vertices[4].x = temppt->polygons[5].lines[0].sp.x; 
  vertices[4].y = temppt->polygons[5].lines[0].sp.y; 
  vertices[4].z = temppt->polygons[5].lines[0].sp.z;

  vertices[5].x = temppt->polygons[5].lines[0].ep.x; 
  vertices[5].y = temppt->polygons[5].lines[0].ep.y; 
  vertices[5].z = temppt->polygons[5].lines[0].ep.z;

  vertices[6].x = temppt->polygons[5].lines[2].sp.x; 
  vertices[6].y = temppt->polygons[5].lines[2].sp.y; 
  vertices[6].z = temppt->polygons[5].lines[2].sp.z;

  vertices[7].x = temppt->polygons[5].lines[2].ep.x; 
  vertices[7].y = temppt->polygons[5].lines[2].ep.y; 
  vertices[7].z = temppt->polygons[5].lines[2].ep.z;

  for(int i = 0; i < 8; i++)
  {
	final_vertices_x[i] = vertices[i].x;
	final_vertices_y[i] = vertices[i].y;
	final_vertices_z[i] = vertices[i].z;
  }

  if (is_initial)
    set_init_vertices(vertices);
  else
    show_vertices(vertices);
}

/*
 * ̗lq摜Ƃĕ\(~)
 */
void output_scene_positions_to_image_cylinder(int is_initial,
				     double x, double y, double z,
				     double tx, double ty, double tz)
{
  point upper[8], lower[8];
  
//  copy_cylinder(modelcy, tempcy);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  double rad = modelcy->disks[0].radius;
  double uz = modelcy->disks[0].center.z;
  double lz = modelcy->disks[1].center.z;
    
  for(int i = 0; i < 8; i++)
  {
	upper[i].x = lower[i].x = rad * cos(deg_to_rad(45*i));
	upper[i].y = lower[i].y = rad * sin(deg_to_rad(45*i));
	upper[i].z = uz;
	lower[i].z = lz;

  }

  //transform_cylinder(tempcy, x, y, z, tx, ty, tz);
  transform_cylinder_image(upper, lower, x, y, z, tx, ty, tz);
  

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */

    for(int i = 0; i < 16; i++)
  {
	  if(i < 8)
	  {
		  final_cylinder_vertices_x[i] = upper[i].x;
		  final_cylinder_vertices_y[i] = upper[i].y;
		  final_cylinder_vertices_z[i] = upper[i].z;
	  }
	  else
	  {
		  final_cylinder_vertices_x[i] = lower[i-8].x;
		  final_cylinder_vertices_y[i] = lower[i-8].y;
		  final_cylinder_vertices_z[i] = lower[i-8].z;
	  }
  }

  if (is_initial)
    set_init_cylinder_vertices(upper, lower);
  else
    show_cylinder_vertices(upper, lower);
}

#if 0
int read_point_data(char *filename)
{
  FILE	*fp;
  errno_t	err;
  int	point_num = 0;
  double	x, y, z, nx, ny, nz;

  if ((err = fopen_s(&fp, filename, "r")) == NULL)
    {
      fprintf(stderr, "File %s not found !!!\n", filename);
      exit(-1);
    }
  while (fscanf(fp, "%lf %lf %lf %lf %lf %lf\n", &x, &y, &z, &nx, &ny, &nz) != EOF){
    points[point_num].x = x;
    points[point_num].y = y;
    points[point_num].z = z;
    points[point_num].nx = nx;
    points[point_num].ny = ny;
    points[point_num].nz = nz;
    point_num++;
  }
  fclose(fp);

  return(point_num);
}

void write_point_data(char *filename)
{
	FILE *fp; 
	errno_t	err;
	int i;

    
	if ((err = fopen_s(&fp, filename, "w")) != 0){
		fprintf(stderr, "file %s cannot be opened.\n", filename);
		exit(-1);
	}
	for (i = 0; i < point_num; i++){
		fprintf(fp, "%f %f %f %f %f %f\n", points[i].x, points[i].y, points[i].z, points[i].nx, points[i].ny, points[i].nz);
	}
	fclose(fp);
}
#endif

void transform_scene_positions_to_image_(int is_initial,
				     double x, double y, double z,
				     double tx, double ty, double tz)
{
  point vertices[8];
  
  copy_polytope(modelpt, temppt);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  transform_polytope(temppt, x, y, z, tx, ty, tz);

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */
  vertices[0].x = temppt->polygons[2].lines[0].sp.x;
  vertices[0].y = temppt->polygons[2].lines[0].sp.y; 
  vertices[0].z = temppt->polygons[2].lines[0].sp.z;

  vertices[1].x = temppt->polygons[2].lines[0].ep.x; 
  vertices[1].y = temppt->polygons[2].lines[0].ep.y; 
  vertices[1].z = temppt->polygons[2].lines[0].ep.z;

  vertices[2].x = temppt->polygons[2].lines[2].sp.x; 
  vertices[2].y = temppt->polygons[2].lines[2].sp.y; 
  vertices[2].z = temppt->polygons[2].lines[2].sp.z;

  vertices[3].x = temppt->polygons[2].lines[2].ep.x; 
  vertices[3].y = temppt->polygons[2].lines[2].ep.y; 
  vertices[3].z = temppt->polygons[2].lines[2].ep.z;

  vertices[4].x = temppt->polygons[5].lines[0].sp.x; 
  vertices[4].y = temppt->polygons[5].lines[0].sp.y; 
  vertices[4].z = temppt->polygons[5].lines[0].sp.z;

  vertices[5].x = temppt->polygons[5].lines[0].ep.x; 
  vertices[5].y = temppt->polygons[5].lines[0].ep.y; 
  vertices[5].z = temppt->polygons[5].lines[0].ep.z;

  vertices[6].x = temppt->polygons[5].lines[2].sp.x; 
  vertices[6].y = temppt->polygons[5].lines[2].sp.y; 
  vertices[6].z = temppt->polygons[5].lines[2].sp.z;

  vertices[7].x = temppt->polygons[5].lines[2].ep.x; 
  vertices[7].y = temppt->polygons[5].lines[2].ep.y; 
  vertices[7].z = temppt->polygons[5].lines[2].ep.z;

  for(int i = 0; i < 8; i++)
  {
	final_vertices_x[i] = vertices[i].x;
	final_vertices_y[i] = vertices[i].y;
	final_vertices_z[i] = vertices[i].z;
  }
}

void transform_scene_positions_to_image_cylinder(int is_initial,
				     double x, double y, double z,
				     double tx, double ty, double tz)
{
  point upper[8], lower[8];
  
//  copy_cylinder(modelcy, tempcy);

  fprintf(stderr, " x= %f, y= %f, z=%f, tx = %f, ty=%f, tz=%f\n",
	  x, y, z, tx, ty, tz);

  double rad = modelcy->disks[0].radius;
  double uz = modelcy->disks[0].center.z;
  double lz = modelcy->disks[1].center.z;
   
  for(int i = 0; i < 8; i++)
  {
	upper[i].x = lower[i].x = rad * cos(deg_to_rad(45*i));
	upper[i].y = lower[i].y = rad * sin(deg_to_rad(45*i));
	upper[i].z = uz;
	lower[i].z = lz;

  }
  //transform_cylinder(tempcy, x, y, z, tx, ty, tz);
  transform_cylinder_image(upper, lower, x, y, z, tx, ty, tz);

/* 
 *     fprintf(stderr, "AfterIni Normal[%d] = (%f, %f, %f)\n",
 *	       i, temppt->polygons[i].nx, temppt->polygons[i].ny, temppt->polygons[i].nz);
 */

/* 
 *   printf("after: \n");
 */

    for(int i = 0; i < 16; i++)
  {
	  if(i < 8)
	  {
		  final_cylinder_vertices_x[i] = upper[i].x;
		  final_cylinder_vertices_y[i] = upper[i].y;
		  final_cylinder_vertices_z[i] = upper[i].z;
	  }
	  else
	  {
		  final_cylinder_vertices_x[i] = lower[i-8].x;
		  final_cylinder_vertices_y[i] = lower[i-8].y;
		  final_cylinder_vertices_z[i] = lower[i-8].z;
	  }
  }

}




/* 
 * #define POINT_DATA_FILE "data2-2.dat"
 */

/* 
 * #define EVAL_THRESH 0.01
 */
/* 
 * #define EVAL_THRESH 0.005	   //Swissranger
 */
/* 
 * #define EVAL_THRESH 10.0
 */
/*
 *#define EVAL_THRESH 5.0
 */
  
 //#define EVAL_THRESH 3.0
 
  //20111105
  #define EVAL_THRESH 0.001
 
  #define MAX_COUNT2 5

int LocateObject(int object_type)
{
	// parameter retp;
	// 20110425 mod by goto
	static parameter retp;
	double	eval;
	int	count2=0;

	fprintf(stderr, "locate obejct\n");

	if (forexval == NULL){ // no foreground data
		fprintf(stderr, "Acquire the foreground data first.\n\n");
		getchar();
		return 0;
	}

	initialize_icp3d(object_type);
	printf("initialize_ok\n");

	convert_point_data(&point_num, points); // data set is in the foreground values.

	//for debug

#ifdef PRINT_POINTS_CORRESPONDENCE

	std::ofstream fout;
	char filename_boxresult[MAXCHARS];

	sprintf_s(filename_boxresult, MAXCHARS, "boxresult%04d.txt", objectid);
	objectid++;

	printf_s("%s\n",filename_boxresult);

	fout.open(filename_boxresult, std::ios::out);

	for(int i = 0; i < point_num; i++)
	{
		fout << points[i].x << ' ' << points[i].y << ' ' << points[i].z << '\n';
	}
	
	fout.close();

#endif
  printf("point_num = %d\n", point_num);
/* 
 *   for(i = 0; i < point_num; i++){
 *     printf("(%f, %f, %f) : normal(%f, %f, %f)\n",
 *	      points[i].x, points[i].y, points[i].z,
 *	      points[i].nx, points[i].ny, points[i].nz);
 *	 
 *   }
 */

//  printf("ok ? ");
//  getchar();

    
  printf("distUpperSurface:%3.3f\n",distUpperSurface);
  printf("averageUpperSurface(%3.3f, %3.3f, %3.3f)\n",averageUpperSurface.x, averageUpperSurface.y, averageUpperSurface.z);
  printf("vec1(%3.3f, %3.3f, %3.3f)\n",vec1UpperSurface.x, vec1UpperSurface.y, vec1UpperSurface.z);
  printf("vec2(%3.3f, %3.3f, %3.3f)\n",vec2UpperSurface.x, vec2UpperSurface.y, vec2UpperSurface.z);	
  printf("vec3(%3.3f,%3.3f, %3.3f)\n",vec3UpperSurface.x, vec3UpperSurface.y, vec3UpperSurface.z);

 // getchar();

  //f~
  if(object_type == 1)
  {
	  double modelHeight;

	  //f
	  modelHeight = CylinderHeight * 2.0;

	  //getchar();

	  //ʂ̏dS
	  pp[0].x = averageUpperSurface.x;
	  pp[0].y = averageUpperSurface.y;
	  pp[0].z = averageUpperSurface.z;

	  //ʂ̏dS
	  pp[1].x = pp[0].x - modelHeight * vec3UpperSurface.x;
	  pp[1].y = pp[0].y - modelHeight * vec3UpperSurface.y;
	  pp[1].z = pp[0].z - modelHeight * vec3UpperSurface.z;

	  //for debug
	  /*
	  printf("p0(%3.3f, %3.3f, %3.3f)\n",pp[0].x, pp[0].y, pp[0].z);
	  printf("p1(%3.3f, %3.3f, %3.3f)\n",pp[1].x, pp[1].y, pp[1].z);
*/
	    //2_Ȃ̂ŒڃxNgvZďpvZ
	  //AISTp[c莞ɎgpD

 		calc_initial_pose_notpca(2,pp,&retp);
/*
 *	  calc_initial_pose2(point_num, points, &retp);
 */
  }
  else
  {
	  //f̂
	  double a, b, c;

	  double BlockX, BlockY, BlockZ;

	  BlockX = BoxWX;
	  BlockY = BoxWY;
	  BlockZ = BoxWZ;	  

	  printf("BlockX:%3.3f, BlockY:%3.3f, BlockZ:%3.3f\n", BlockX, BlockY, BlockZ);

	  if(object_type == BOX_XY)
	  {
		  printf("X-Y\n");

		  a = BlockX;
		  b = BlockY;
		  c = (BlockZ * 2.0);
	  }
	  else if(object_type == BOX_YZ)
	  {
		  printf("Y-Z\n");

		  a = BlockZ;
		  b = BlockY;
		  c = (BlockX * 2.0);
	  }
	  else if(object_type == BOX_XZ)
	  {
		  printf("X-Z\n");

		  a = BlockZ;
		  b = BlockX;
		  c = (BlockY * 2.0);
	  }

	  pp[0].x = averageUpperSurface.x + (a * vec1UpperSurface.x) + (b * vec2UpperSurface.x);
	  pp[0].y = averageUpperSurface.y + (a * vec1UpperSurface.y) + (b * vec2UpperSurface.y);
	  pp[0].z = averageUpperSurface.z + (a * vec1UpperSurface.z) + (b * vec2UpperSurface.z);

	  pp[1].x = averageUpperSurface.x - (a * vec1UpperSurface.x) + (b * vec2UpperSurface.x);
	  pp[1].y = averageUpperSurface.y - (a * vec1UpperSurface.y) + (b * vec2UpperSurface.y);
	  pp[1].z = averageUpperSurface.z - (a * vec1UpperSurface.z) + (b * vec2UpperSurface.z);

	  pp[2].x = averageUpperSurface.x - (a * vec1UpperSurface.x) - (b * vec2UpperSurface.x);
	  pp[2].y = averageUpperSurface.y - (a * vec1UpperSurface.y) - (b * vec2UpperSurface.y);
	  pp[2].z = averageUpperSurface.z - (a * vec1UpperSurface.z) - (b * vec2UpperSurface.z);

	  pp[3].x = averageUpperSurface.x + (a * vec1UpperSurface.x) - (b * vec2UpperSurface.x);
	  pp[3].y = averageUpperSurface.y + (a * vec1UpperSurface.y) - (b * vec2UpperSurface.y);
	  pp[3].z = averageUpperSurface.z + (a * vec1UpperSurface.z) - (b * vec2UpperSurface.z);

	  pp[4].x = pp[0].x - c * vec3UpperSurface.x;   
	  pp[4].y = pp[0].y - c * vec3UpperSurface.y;
	  pp[4].z = pp[0].z - c * vec3UpperSurface.z;

	  pp[5].x = pp[1].x - c * vec3UpperSurface.x;   
	  pp[5].y = pp[1].y - c * vec3UpperSurface.y;
	  pp[5].z = pp[1].z - c * vec3UpperSurface.z;

	  pp[6].x = pp[2].x - c * vec3UpperSurface.x;   
	  pp[6].y = pp[2].y - c * vec3UpperSurface.y;
	  pp[6].z = pp[2].z - c * vec3UpperSurface.z;

	  pp[7].x = pp[3].x - c * vec3UpperSurface.x;   
	  pp[7].y = pp[3].y - c * vec3UpperSurface.y;
	  pp[7].z = pp[3].z - c * vec3UpperSurface.z;


	  //for debug
	  /*
	  printf("p0(%3.3f, %3.3f, %3.3f)\n",pp[0].x, pp[0].y, pp[0].z);
	  printf("p1(%3.3f, %3.3f, %3.3f)\n",pp[1].x, pp[1].y, pp[1].z);
	  printf("p2(%3.3f, %3.3f, %3.3f)\n",pp[2].x, pp[2].y, pp[2].z);
	  printf("p3(%3.3f, %3.3f, %3.3f)\n",pp[3].x, pp[3].y, pp[3].z);
	  printf("p4(%3.3f, %3.3f, %3.3f)\n",pp[4].x, pp[4].y, pp[4].z);
	  printf("p5(%3.3f, %3.3f, %3.3f)\n",pp[5].x, pp[5].y, pp[5].z);
	  printf("p6(%3.3f, %3.3f, %3.3f)\n",pp[6].x, pp[6].y, pp[6].z);
	  printf("p7(%3.3f, %3.3f, %3.3f)\n",pp[7].x, pp[7].y, pp[7].z);
*/

/*	  
 *	  calc_initial_pose2(point_num, points, &retp);
 */
	  //AISTp[c莞ɎgpD

	calc_initial_pose2(8, pp, &retp);
 
  }

  fprintf(stderr, " Initial Pose: Pos(%f, %f, %f), Ori(%f, %f, %f)\n",
	  retp.x, retp.y, retp.z, rad_to_deg(retp.tx), rad_to_deg(retp.ty), rad_to_deg(retp.tz));

#ifdef DEBUG
  printf("show_axis\n");
  show_axis(averagep, axisp);

  printf("show_initpoints\n");
  if(object_type == 0)
	show_initpoints(pp);
  else
	show_initpoints_cylinder(pp);
#else

#endif

#ifdef OUTPUT_IMAGE  
  if(object_type == 1)
	output_scene_positions_to_image_cylinder(0, retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
  else
	output_scene_positions_to_image(1, retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);

#else
  //for debug
  //if(object_type == 0)
	//output_scene_positions("init-vertices.dat", retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
#endif
   
	vest_param.estimate_error = VERY_LARGE;
	correspondence_of_vestp = VERY_SMALL_INT;

	previous_selected_surface=VERY_SMALL_INT;

  while (1){

	  if(object_type == 1)
	  {
		  //~D
		  printf("esitimation_cylinder\n");
		  //Ăʂ獇킹
		  eval = icp_svd_cylinder2(&retp);
		  fprintf(stderr, "Finish icp_svd_cylinder2 (surface-wise), eval = %f\n", eval);
		  //Ŝ̖ʂ킹
		  eval = icp_svd_cylinder(&retp);
		  fprintf(stderr, "Finish icp_svd_cylinder (all surfaces),  eval = %f\n", eval);
	  }
	  else
	  {
		  //D
		  printf("estimation_box\n");
		  //Ăʂ獇킹
		  eval = icp_svd2(&retp);
		  fprintf(stderr, "Finish icp_svd2 (surface-wise), eval = %f\n", eval);
		  //Ŝ̖ʂ킹		 
		  eval = icp_svd(&retp);
		  fprintf(stderr, "Finish icp_svd (all surfaces),  eval = %f\n", eval);
	  }
    /* 1񕪂̃[vI */
    
	  fprintf(stderr, "==========================================================\n");
	  fprintf(stderr, "Answer = (%f, %f, %f, %f, %f, %f) [%f]\n",
				 retp.x, retp.y, retp.z, rad_to_deg(retp.tx), rad_to_deg(retp.ty),rad_to_deg(retp.tz), eval);
	  fprintf(stderr, "==========================================================\n");

/* 
 *     print_detail = 1; print_detail2 = 1;
 */
/* 
 *     disp_errors=1;
 */

    if (eval < EVAL_THRESH)
	{	
		//fƃf[^̋臒lȉɂȂI
		break;
	}

    count2++;
	fprintf(stderr, "count2 = %d\n", count2);
    if (count2 > MAX_COUNT2) 
	{
		//ȏJԂI
		break;
	}
  }

  //ŗǂ̌ʂobject_pose

  object_pose.x = vest_param.pose.position.x;
  object_pose.y = vest_param.pose.position.y;
  object_pose.z = vest_param.pose.position.z;
  object_pose.tx = vest_param.pose.orientation.r;
  object_pose.ty = vest_param.pose.orientation.p;
  object_pose.tz = vest_param.pose.orientation.y;

/*  
  object_pose = retp;
*/
  printf("object_pose x : %3.3f, y : %3.3f z : %3.3f, tx : %3.3f ty : %3.3f, tz : %3.3f \n"
	  ,object_pose.x, object_pose.y, object_pose.z, object_pose.tx, object_pose.ty, object_pose.tz);

  printf("correspondence_of_vestp : %6.6f\n",correspondence_of_vestp);
/*
 * printf("ok ? ");
 * getchar();
 */
  /*
    8̒_o
  */
#ifdef OUTPUT_IMAGE
  if(object_type == 1)
  {
  output_scene_positions_to_image_cylinder(0, 
				  retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
  }
  else
  {
  output_scene_positions_to_image(0, 
				  retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
  }
#else
  //for debug
  if(object_type == 1)
	 transform_scene_positions_to_image_cylinder(0, retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
  else
	 transform_scene_positions_to_image_(0, retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);

	//output_scene_positions("final-vertices.dat", retp.x, retp.y, retp.z, retp.tx, retp.ty, retp.tz);
#endif
  
  closing();

  return 1;
}

#endif