#include "../cvutil/cvutil.h"
#include <iostream>
#include <sstream>


using namespace std;

static const char *PATH = "C:/Users/Junichi-S/Desktop/QVGA-3020/";
static const char *SUFFIX = "bmp";

static const int IMAGE_NUM = 8;


#pragma comment(lib, "cv200.lib")
#pragma comment(lib, "cxcore200.lib")
#pragma comment(lib, "highgui200.lib")


int main(void)
{
	ostringstream path;
	path.str("");
	path << PATH << "0." << SUFFIX;
	cout << "test [" << path.str().c_str() << "]" << endl;

	opencv::cvutil::Image<IPL_DEPTH_8U> src_img(path.str().c_str(), CV_LOAD_IMAGE_COLOR);
	opencv::cvutil::Image<IPL_DEPTH_8U> dst_img(src_img.getWidth(), src_img.getHeight(), src_img.getNChannels());
	opencv::cvutil::Image<IPL_DEPTH_32F> mapx(src_img.getWidth(), src_img.getHeight(), 1);
	opencv::cvutil::Image<IPL_DEPTH_32F> mapy(src_img.getWidth(), src_img.getHeight(), 1);

	CvMat *intrinsic, *distortion;
	CvFileStorage *fs;
	CvFileNode *param;

	fs = cvOpenFileStorage ("../camcalib/ac-022-3020-qvga.xml", 0, CV_STORAGE_READ);
	param = cvGetFileNodeByName (fs, NULL, "intrinsic");
	intrinsic = (CvMat *) cvRead (fs, param);
	param = cvGetFileNodeByName (fs, NULL, "distortion");
	distortion = (CvMat *) cvRead (fs, param);
	cvReleaseFileStorage (&fs);

	// (1)cݕ␳̂߂̃}bv
	cvInitUndistortMap (intrinsic, distortion, mapx, mapy);

	for(int i = 0; i < IMAGE_NUM; i ++){
		path.str("");
		path << PATH << i << "." << SUFFIX;
		cout << "[" << path.str().c_str() << "]" << endl;
		src_img.load(path.str().c_str(), CV_LOAD_IMAGE_COLOR);
		
		// (2)cݕ␳
		cvRemap (src_img, dst_img, mapx, mapy);
		src_img.show("Distortion");
		dst_img.show("UnDistortion");

		path.str("");
		path << PATH << i << "ud." << SUFFIX;
		dst_img.save(path.str().c_str());
		cvWaitKey();
	}
	cvReleaseMat (&intrinsic);
	cvReleaseMat (&distortion);

	return 0;
}